#include "io.h"
#include "fcntl.h"
#include "stdlib.h"
#include "stdio.h"
#include "backgrnd.h"
#include <DOS.H>

int BackGroundError=0;
char *CalledFile;

int ShowBackGround(char *FileName)
{
char far *Buffer=(char far*) malloc(64000);

CalledFile=FileName;

if(Buffer==0) { BackGroundError=1; return -1; }
int handle;

if((handle=open(FileName, O_RDWR))==-1)  { BackGroundError=2; return -1; }

if((read(handle,Buffer,64000))==-1)  { BackGroundError=3; return -1; }

close(handle);

asm {

pushf
cld
push ds
push es
push si
push di
push cx
push ax

mov ax,0a000h
mov es,ax
xor di,di
lds si,dword ptr Buffer

mov cx,32000
rep movsw

pop ax
pop cx
pop di
pop si

pop es
pop ds

popf
};

BackGroundError=0;
return 0;
}


int  LoadPalette(char *PalFile)
{
char Palette[1000];

int handle;

if((handle=_open(PalFile, O_RDWR))==-1)  { printf("Unable to open palette from: %s!",PalFile); return -1; }
int k=0;
if((k=_read(handle,Palette,768))==-1)    { printf("Unable to read palette from: %s!",PalFile); return -1; }

close(handle);

int sg=FP_SEG(Palette);
int so=FP_OFF(Palette);

asm {

mov ax,1012h
mov dx,sg
mov es,dx
mov dx,so

xor bx,bx
mov cx,256
int 10h

};

return 0;
}