#include "stdio.h"
#include "dos.h"
#include "conio.h"
#include "io.h"
#include "fcntl.h"
#include "string.h"
#include "stdlib.h"
#include "gamegrab.h"

//#include "sprite.h"

static int x,y;
static int sizex=16,sizey=16;
int fl=0;   // 0 -- no box on screen, 1 -- yes
static int step=16;
int ax,ay,i;

extern unsigned int _stklen=8000;

int handle;
char res;

static char filename[10];
int xx,yy;

typedef struct _SPR_HDR_ {

char NK[2];      // Signature of Sprite Editor: 'NK';
char Version;
char VideoMode;
char Type;
int  SizeX;
int  SizeY;
int  DataLen;    // Lengh of base Data: mustn't be equal to zero;
int  MaskLen;    // Length of Mask: If zero -> no mask in sprite;

} SPR_HDR;


char SaveData[2000]={ 0 };

int VGA=0;

unsigned char getpixel(int,int);

#define INTR 0X09
int flag=0;         // 0--means not active

int  MaxY;
int  BPL; // Bytes Per Line
int  CurrScroll;
void ScrollDown(void);
void ScrollUp(void);
void MakeOffset(unsigned);
void interrupt (*oldhandler)(void);
int  GetPage(int);
void maingrab(void);
void hline(int,int,int,int );
void vline(int,int,int,int);
void SetVisualPage(int);

void MakeBPL(void);
unsigned char far string[1000]={ 0 };
int number=0;     // number of saved files
int VGAnumber=0;
int EGAnumber=0;
int PALnumber;
int REGnumber;
int BytesPerPage;
int OFR;

int ScrStart=0xa000;

SPR_HDR icon;

struct VREG {

char BIOSmode;
// start adress reg.
char SARhigh;
char SARlow;

int HTR;
int HDR;
int HSR;
int HSPWR;
int VTR;
int VTAR;
int VDR;
int VSPR;
int IMR;
int MSLR;
int CSR;
int CER;
int CLRh;
int CLRl;

int RR;
int CMR;
int CPWER;
int CGSR;
int MMR;

int SRR;
int SRER;
int CCR;
int DRFS;
int RPSR;
int MDR;
int MIR;
int CDCR;
int BMR;
int ModeControl;

int OFR;

} vreg;


char ReadReg(int r,char v)
{

asm {
mov dx,r
mov al,v
out dx,al

inc dx
in  al,dx
};

return _AL;
}

char curmode=3;
char curpage=0;

char QuitFlag=0;

int key;
int tmp1,tmp2;

void GetPalette(void)
{
//tmp1=FP_SEG(string);

asm {

mov ax,1017h
mov dx,seg string
mov es,dx
mov dx,offset string

xor bx,bx
mov cx,256
int 10h

};

}



char getvmode(void)
{
char mode;

asm mov ah,0fh;
asm int 10h;
asm mov curpage,bh;
mode=_AL;

if(mode==0x13) VGA=1;
else           VGA=0;

return mode;

}


int getkey(void)
{
asm xor ax,ax;
asm int 16h;
return _AX;
}

#define BYTEOF(x,y) ((y)*OFR*2+((x)/8))
#define BITOF(x)  (0x80>>((x)&0x07))        // 000x0000


void SETREG(int port,char reg,char value)
{
asm mov dx,port;
asm mov al,reg;
asm mov ah,value
asm out dx,ax;
}

#define EnablePlanes(p)   SETREG(0x3c4,2,p)

#define SetWriteMode(m) asm {\
			      mov dx,3ceh;\
			      mov ah,5;\
			      mov al,m;\
			      out dx,ax;\
			    };

#define GDC              0x3CE
#define GDCReset         0x00
#define GDCEnable        0x01
#define GDCColorCompare  0x02
#define GDCDataRotate    0x03
#define GDCReadMapSel    0x04
#define GDCMode          0x05
#define GDCMisc          0x06
#define GDCColorDC       0x07
#define GDCBitMask       0x08

void SETREG(int,char,char);
void SetWordReg(int,int);

#define SETMASK(m) SETREG(GDC,GDCBitMask,(m))



void SaveDACs(void)
{
int sg,of;

sg=FP_SEG(SaveData);
of=FP_OFF(SaveData);

asm {

mov ax,1c01h
mov cx,00000111b
mov bx,sg
mov es,bx
mov bx,of
int 10h

};

}

void RestoreDACs(void)
{

int sg,of;

sg=FP_SEG(SaveData);
of=FP_OFF(SaveData);

asm {

mov ax,1c02h
mov cx,00000111b
mov bx,sg
mov es,bx
mov bx,of
int 10h

};



}

void ApogeePutPixel(int x,int y,char color)
{
char c;
int k;
int off;
int sg;
char mask;

k=ScrStart%16;

off=BYTEOF(x,y)+k;
sg=0xa000+ScrStart/16;

mask=BITOF(x);

asm {

mov dx,3ceh
mov al,5
out dx,al
inc dx
mov al,0
out dx,al

mov dx,3ceh
mov al,3
out dx,al
inc dx
mov al,00011000b
out dx,al

mov dx,3ceh
mov al,8
out dx,al
inc dx
mov al,mask
out dx,al

mov ax,sg
mov es,ax
mov bx,off

mov al,es:[bx]
mov al,0
mov es:[bx],al

mov dx,3c4h
mov al,2
out dx,al
inc dx
mov al,15
out dx,al


mov al,0ffh
mov es:[bx],al

mov dx,3ceh
mov al,3
out dx,al
inc dx
mov al,0
out dx,al



};

}


char ApogeeGetPixel(int x,int y)
{
char c;
int k;
int off;
int sg;
char mask;
char p1,p2,p3,p4;
char col;

k=ScrStart%16;

off=BYTEOF(x,y)+k;
sg=0xa000+ScrStart/16;

mask=BITOF(x);

asm {

mov bx,sg
mov es,bx
mov bx,off

mov dx,3ceh
mov al,5
out dx,al
inc dx
mov al,0
out dx,al

dec dx
mov al,4
out dx,al
inc dx
mov al,0
out dx,al

mov cl,es:[bx]
mov p1,cl

mov dx,3ceh
mov al,5
out dx,al
inc dx
mov al,0
out dx,al

dec dx
mov al,4
out dx,al
inc dx
mov al,1
out dx,al

mov cl,es:[bx]
mov p2,cl

mov dx,3ceh
mov al,5
out dx,al
inc dx
mov al,0
out dx,al

dec dx
mov al,4
out dx,al
inc dx
mov al,2
out dx,al

mov cl,es:[bx]
mov p3,cl

mov dx,3ceh
mov al,5
out dx,al
inc dx
mov al,0
out dx,al

dec dx
mov al,4
out dx,al
inc dx
mov al,3
out dx,al

mov cl,es:[bx]
mov p4,cl

};

p1=p1 & mask;
p2=p2 & mask;
p3=p3 & mask;
p4=p4 & mask;

col=0;

if((p1 & mask)) col+=1;
if((p2 & mask)) col+=2;
if((p3 & mask)) col+=4;
if((p4 & mask)) col+=8;

return col;
}



   void interrupt handler(void)
{
char NL=0;

if(flag!=0) goto quit;

//  Cast Alt-K to call

asm {

 push ax
 in al,60h
 cmp al,37
 jz key
 cmp al,70     // ScrollLock
 jne go99

 mov NL,al
 pop ax
 jmp our_prog
}

go99:

asm {
 cmp al,76
 pop ax
 jz our_prog
 jmp quit

};

key:

asm {
 pop ax
 push ax
 push es
 xor ax,ax
 mov es,ax
 mov al,es:[417h]
 test al,8
 pop es
 pop ax
 jnz our_prog
 jmp quit

};


our_prog:

asm {

 push ax
 in al,61h
 mov ah,al
 or al,80h
 out 61h,al
 xchg al,ah
 out 61h,al
 mov al,20h
 out 20h,al
 pop ax

};


asm {

push ax
push bx
push cx
push dx

};

asm mov ah,0fh;
asm int 10h;
asm mov curpage,bh;
asm mov curmode,al;

asm {
 pop dx
 pop cx
 pop bx
 pop ax
 sti

};

flag=1;

curmode=getvmode();

MakeBPL();

switch(curmode) {

case 0x0d:
case 0x0e:
case 0x10:
case 0x11:
case 0x13:

SaveDACs();
RestoreDACs();

ScrStart=ReadReg(0x3d4,0x0c);
ScrStart<<=8;
ScrStart+=ReadReg(0x3d4,0x0d);

OFR=ReadReg(0x3d4,0x13);

BPL=OFR*2;

if(NL==0) maingrab();
else
{

if(curmode==0x0D)
{

filename[0]=0;
itoa(EGAnumber,filename,10);
strcat(filename,".EGA");

handle=_creat(filename,FA_ARCH);

for(ay=0; ay<200; ay++)
{

  for(i=0,ax=0; ax<320; i++,ax++)
  string[i]=getpixel(ax,ay);

res=_write(handle,&string,320);

if(res==-1)
{
sound(10000);
delay(300);
nosound();
}

}

close(handle);

filename[0]=0;
strcat(filename,"EGA");
itoa(EGAnumber,filename,10);
strcat(filename,".PAL");

handle=_creat(filename,FA_ARCH);
if(handle==-1) goto EGAFileErr;

GetPalette();
res=_write(handle,&string,768);

close(handle);

EGAFileErr:

if(res==-1)
{
sound(10000);
delay(300);
nosound();
}

EGAnumber++;
sound(1000);
delay(30);
nosound();
}
break;


}

break;

default:

sound(2000);
delay(200);
nosound();

};


flag=0;
RestoreDACs();
goto full_quit;


quit:
oldhandler();

full_quit:
;

}





  void main(void)
{


 puts("Game Explorer & GRaBer Version 4.4 BY Alex Chudnovsky");
 puts("Copyright (C) Mythical Sofware Group 1994/95");
 puts("");
 puts(" Keys in work mode:");
 puts("Arrows       -> move rectangle;");
 puts("ESC or SPACE -> leave work mode;");
 puts("ENTER        -> switch between two remove modes;");
 puts("F2           -> save image located in the rectangle;");
 puts("F3           -> save EGA 320x200,16 colors image visible on screen;");
 puts("Grey Plus    -> increase rectangle step;");
 puts("Grey Minus   -> decrease rectangle step;");
 puts("'0'..'7'     -> set new work video page;");
 puts("P & '0'..'7' -> make new visual page;");
 puts("PageUp       -> hardware scrolling up;");
 puts("PageDown     -> hardware scrolling down;");
 puts("DIV & MUL    -> changing of BPL (Bytes Per Line) on screen;");
 puts("R            -> restore default BPL;");
 puts("S            -> show mouse pointer (if any);");
 puts("H            -> hide mouse pointer (if any);");
 puts("V            -> save VGA 256 color picture in file;");
 puts("E            -> equialize rectangle sizes to 16x16;");
 puts("I            -> Initialize current video mode (helps to detect some things);");
 puts("D            -> Register dump in file xxx.REG");
 puts("A            -> Save VGA pAlette in PALxxx.PAL");
 puts("W            -> Apogee iD Software Crack -- Can Write Pixels!");

 puts("\n\rCast Alt-K or '5' on numeric keypad to enter work mode...");

oldhandler=getvect(INTR);
setvect(INTR, handler);

keep(0,20000/16);

}


void putpixel(int x,int y,char col)
{
char color;

if(curmode==0x13)
{
color=getpixel(x,y);

color=~color;

_AH=0x0c;
_BH=curpage;
_CX=x;
_DX=y;
_AL=color;
asm int 10h;
}

else
{

/*
_AH=0x0c;
_BH=curpage;
_CX=x;
_DX=y;
_AL=15+0x80;
asm int 10h;
*/

ApogeePutPixel(x,y,col);
}

}


void box(int x1,int y1,int x2,int y2)
{
int x,y;

hline(x1, y1, x2, y1);
hline(x1, y2, x2, y2);

vline(x1, y1, x1, y2);
vline(x2, y1, x2, y2);

}



 void hline(int x1,int y1,int x2,int y2)
{
int x;

 for(x=x1; x<x2; x++)
 putpixel(x,y1,15);

}

 void vline(int x1,int y1,int x2,int y2)
{
int y;


 for(y=y1;y<y2;y++)
 putpixel(x1,y,15);

}


unsigned char getpixel(int x,int y)
{

if(curmode==0x13)
{
_AH=0x0d;
_BH=curpage;
_CX=x;
_DX=y;
asm int 10h;
}
else
{
_AL=ApogeeGetPixel(x,y);
}

return _AL;
}

  void maingrab(void)
{
box(x,y,x+sizex,y+sizey);

begin:
key=getkey();

switch(key) {

case UP:    box(x,y,x+sizex,y+sizey);
	    if(fl==0) {
	     y-=step;
	     box(x,y,x+sizex,y+sizey);
		      }
	    else {
	     sizey-=step;
	     box(x,y,x+sizex,y+sizey);
		 }
	      break;


case DOWN:
box(x,y,x+sizex,y+sizey);
	    if(fl==0) {
	     y+=step;
	     box(x,y,x+sizex,y+sizey);
		      }
	    else {
	     sizey+=step;
	     box(x,y,x+sizex,y+sizey);
		 }
		 break;

case DIV: if(BPL>1) BPL--; break;

case MUL: BPL++; break;

case RIGHT:
	box(x,y,x+sizex,y+sizey);
	    if(fl==0) {
	     x+=step;

             if(x%2!=0) x++; // Allign by 2;

	     box(x,y,x+sizex,y+sizey);
		      }
	    else {
	     sizex+=step;
	     box(x,y,x+sizex,y+sizey);
		 }
	break;

case GREY_PLUS: step++; break;

case GREY_MINUS: if(step>1) step--; break;

case LEFT:

box(x,y,x+sizex,y+sizey);
	    if(fl==0) {
	     x-=step;
	
	     if(x%2!=0) x--; // Allign by 2;


	     box(x,y,x+sizex,y+sizey);
		      }
	    else {
	     sizex-=step;
	     box(x,y,x+sizex,y+sizey);
		 }

	       break;

case ENTER: if(fl==0) fl=1;
	    else      fl=0;

	    break;

case F3:

if(curmode==0x0D)
{

box(x,y,x+sizex,y+sizey);

filename[0]=0;
itoa(EGAnumber,filename,10);
strcat(filename,".EGA");

handle=_creat(filename,FA_ARCH);

for(ay=0; ay<200; ay++)
{

  for(i=0,ax=0; ax<320; i++,ax++)
  string[i]=getpixel(ax,ay);

res=_write(handle,&string,320);

if(res==-1)
{
sound(10000);
delay(300);
nosound();
}

}

close(handle);

filename[0]=0;
strcat(filename,"EGA");
itoa(EGAnumber,filename,10);
strcat(filename,".PAL");

handle=_creat(filename,FA_ARCH);
if(handle==-1) goto EGAFileErr;

GetPalette();
res=_write(handle,&string,768);

close(handle);

EGAFileErr:

if(res==-1)
{
sound(10000);
delay(300);
nosound();
}

box(x,y,x+sizex,y+sizey);

EGAnumber++;
sound(1000);
delay(30);
nosound();
}
break;

case F2:

icon.NK[0]='N';
icon.NK[1]='K';
icon.Version=10;
icon.VideoMode=curmode;
icon.Type=80;      // GRB file type...
icon.SizeY=sizey;  //sizey;
icon.SizeX=sizex;  //sizex;
icon.DataLen=sizey*sizex;
icon.MaskLen=0;

box(x,y,x+sizex,y+sizey);

filename[0]=0;
itoa(number,filename,10);
strcat(filename,".SPR");

number++;
handle=_creat(filename,FA_ARCH);

res=_write(handle, &icon, sizeof(icon));

if(res==-1)
{

sound(10000);
delay(300);
nosound();

}

for(ay=y+1; ay<y+sizey+1; ay++)
{

  for(i=0,ax=x+1; ax<x+sizex+1; i++,ax++)
  string[i]=getpixel(ax,ay);

res=_write(handle,&string,sizex);

if(res==-1)
{

sound(10000);
delay(300);
nosound();

}

}

close(handle);

box(x,y,x+sizex,y+sizey);

sound(1000);
delay(30);
nosound();

break;

case SPACE:
case ESC:  box(x,y,x+sizex,y+sizey); goto quit;   // exit

case PGUP:   ScrollUp();   break;

case PGDOWN: ScrollDown(); break;

default:

key=(key<<8)>>8;

if((key=='s') || (key=='S'))
{

asm push ax;
asm mov ax,0001h;
asm int 33h;
asm pop ax
}

if((key=='a') || (key=='A'))
{
filename[0]=0;
itoa(PALnumber,filename,10);
strcat(filename,"PAL.PAL");

handle=_creat(filename,FA_ARCH);
if(handle==-1) { puts("PAL creat error!"); goto PALFileErr; }

GetPalette();
_write(handle,string,768);

PALnumber++;
PALFileErr:
close(handle);
}

if((key=='v') || (key=='V'))
{

if(curmode==0x13)
{

box(x,y,x+sizex,y+sizey);

filename[0]=0;
itoa(VGAnumber,filename,10);
strcat(filename,".VGA");

handle=_creat(filename,FA_ARCH);

for(ay=0; ay<200; ay++)
{

  for(i=0,ax=0; ax<320; i++,ax++)
  string[i]=getpixel(ax,ay);

res=_write(handle,&string,320);

if(res==-1)
{

sound(10000);
delay(300);
nosound();

}

}

close(handle);

filename[0]=0;
itoa(VGAnumber,filename,10);
strcat(filename,".PAL");

handle=_creat(filename,FA_ARCH);
if(handle==-1) goto FileErr;

GetPalette();
res=_write(handle,&string,768);

close(handle);

FileErr:

if(res==-1)
{
sound(10000);
delay(300);
nosound();
}

box(x,y,x+sizex,y+sizey);

VGAnumber++;
sound(1000);
delay(30);
nosound();

}

} // End


if((key=='h') || (key=='H'))
{
asm push ax;
asm mov ax,0002h;
asm int 33h;
asm pop ax
}


if((key>='0') || (key<='7'))
{
box(x,y,x+sizex,y+sizey);
curpage=key-'0';
box(x,y,x+sizex,y+sizey);
}

if((key=='r') || (key=='R')) MakeBPL();

if((key=='w') || (key=='W'))
{

for(yy=0; yy<20; yy++)
for(xx=0; xx<20; xx++)
 ApogeePutPixel(xx,yy,14);

}

if((key=='i') || (key=='I')) 
{  
box(x,y,x+sizex,y+sizey);
asm mov ah,0;
asm mov al,curmode;
asm int 10h;
box(x,y,x+sizex,y+sizey);
}

if((key=='d') || (key=='D'))
{
filename[0]=0;
itoa(REGnumber,filename,10);
strcat(filename,".REG");

handle=_creat(filename,FA_ARCH);

vreg.BIOSmode=curmode;

vreg.HTR=ReadReg(0x3d4,0x00);
vreg.HDR=ReadReg(0x3d4,0x01);
vreg.HSR=ReadReg(0x3d4,0x02);
vreg.HSPWR=ReadReg(0x3d4,0x03);
vreg.VTR=ReadReg(0x3d4,0x04);
vreg.VTAR=ReadReg(0x3d4,0x05);
vreg.VDR=ReadReg(0x3d4,0x06);
vreg.VSPR=ReadReg(0x3d4,0x07);
vreg.IMR=ReadReg(0x3d4,0x08);
vreg.MSLR=ReadReg(0x3d4,0x09);

vreg.SARhigh=ReadReg(0x3d4,0x0c);
vreg.SARlow=ReadReg(0x3d4,0x0d);
vreg.CLRh=ReadReg(0x3d4,0x0e);
vreg.CLRl=ReadReg(0x3d4,0x0f);

vreg.RR=ReadReg(0x3c4,0x00);
vreg.CMR=ReadReg(0x3c4,0x01);
vreg.CPWER=ReadReg(0x3c4,0x02);
vreg.CGSR=ReadReg(0x3c4,0x03);
vreg.MMR=ReadReg(0x3c4,0x04);


vreg.SRR=ReadReg(0x3ce,0x00);
vreg.SRER=ReadReg(0x3ce,0x01);
vreg.CCR=ReadReg(0x3ce,0x02);
vreg.DRFS=ReadReg(0x3ce,0x03);

vreg.ModeControl=ReadReg(0x3ce,0x17);

vreg.OFR=ReadReg(0x3d4,0x13);

/*
vreg.=ReadReg(0x3ce,0x02);
vreg.=ReadReg(0x3ce,0x03);
vreg.=ReadReg(0x3ce,0x04);
*/

_write(handle,&vreg,sizeof(vreg));

REGnumber++;
close(handle);
}


if(key=='8')
{  
box(x,y,x+sizex,y+sizey);
sizex=8;
sizey=8;
box(x,y,x+sizex,y+sizey);
}


if((key=='e') || (key=='E'))
{

if((sizex!=16) || (sizey!=16))
{
box(x,y,x+sizex,y+sizey);
sizex=16;
sizey=16;
box(x,y,x+sizex,y+sizey);
}

}


if((key=='p') || (key=='P'))
{

key=getkey();
key=(key<<8)>>8;

if((key>='0') || (key<='7'))
{

SetVisualPage(key-'0');

}

}

break;

};

goto begin;

quit:

;
}

void SetVisualPage(int p)
{

/*
asm {
mov ah,5
mov al,p
int 10h
};
*/

long off=MaxY*BPL*p;

if(off>64000) printf("VisualOffset: %p; Page: %d;\n\r",off,p);

MakeOffset((int) off);
}


void ScrollDown(void)
{

CurrScroll++;

MakeOffset(CurrScroll*BPL);

}


void ScrollUp(void)
{

if(CurrScroll==0) return;
CurrScroll--;

MakeOffset(CurrScroll*BPL);

}


void MakeOffset(unsigned off)
{

asm {

mov bx,off
mov dx,3d4h
mov al,12
out dx,al
inc dx
mov al,bh
out dx,al
dec dx
mov al,13
out dx,al
inc dx
mov al,bl
out dx,al

};

}


void MakeBPL(void)
{

switch(curmode) {

case 0x0d: MaxY=200; BPL=40;  break;

case 0x0e: MaxY=200; BPL=80;  break;

case 0x10: MaxY=350; BPL=80;  break;

case 0x13: MaxY=200; BPL=320; break;

default:   MaxY=200; BPL=40; break;

};

}
