/*

 Objects -- 2 Routines Version 1.0

*/

#include "time.h"
#include "string.h"
#include "fcntl.h"
#include "dos.h"
#include "stdarg.h"
#include "ctype.h"
#include "process.h"
#include "dir.h"
#include "io.h"
#include "pcxlib.h"
#include "alloc.h"
#include "stdio.h"
#include "conio.h"

#include "gamekit.h"
#include "objects.h"
#include "objects2.h"

#include "defines.h"
#include "tkeys.h"
#include "bwg.h"

#include "video.h"
#include "mem.h"

void makeextension(char *name,char *extension);

int yesno(char *title,char *mess)
{
int winlen;


if(VideoGetMaxY()<330)
 winlen=300;
else winlen=strlen(mess)*8+3*8*2;

WINDOW win(-1,-1,winlen,110,title,DLG_FRAME);

win.ShowWindow();
win.SetTextColor(BLACK);
win.RPrint(-1,30,mess,BLACK);

BUTTON yes(win.x+40,win.y+80,60,20,"&Yes",kbEnter);
BUTTON no(win.x+win.length-100,win.y+80,60,20,"&No",kbEsc);

yes.ShowButton();
no.ShowButton();

mouse_show();

EVENT event;

go:

event=_GetEvent();

if(yes.ProcessEvent(&event)==PRESSED) {
					win.DeleteWindow();
					return 0;
				      }

if(no.ProcessEvent(&event)==PRESSED) {
					win.DeleteWindow();
					return 1;
				      }
goto go;

}


int WinMessageBox(char *header,char *text, int style)
{
int bc=VideoGetColor();

int tl=VideoTextWidth(text);
int hl=VideoTextWidth(header);
int winlen=20;
int mx,my;

char str[2];
int lines=0;
int linelen=0;
int k=0;

str[0]=0;
str[1]=0;
int maxline=0;
int tmpline=0;

for(k=0; k<strlen(text); k++)
{

switch(text[k])
{

case '|': lines++;
	  if(maxline<tmpline) maxline=tmpline;
	  tmpline=0;
	  break;

default:  tmpline++; break;

};

}

if(maxline==0) maxline=tmpline;

mx=VideoGetMaxX();
my=VideoGetMaxY();


WINDOW message(-1,-1,maxline*8+2*4*8,80+lines*10,header,DLG_FRAME);
if(style==1) {

	   message.header="Error";
	   message.style=message.style | ERR_FRAME;

	     }

message.ShowWindow();

message.SetTextColor(BLACK);
int curline=0;
char strout[80];

for(k=0; k<strlen(text); k++)
{

int c=0;
int outstyle=-1;

while(1)
{

switch(text[k])
{

case 0:
case '|': goto go00;

case '~': outstyle=16; k++; break;

default:
strout[c]=text[k];
k++; c++;
break;

};

}

go00:

strout[c]=0;
message.RPrint(outstyle,25-8+curline*10,strout,BLACK);
curline++;
outstyle=-1;

}


BUTTON ok(message.x+(message.length)/2-30,(message.y+message.width)-25 ,60,20,"&OK",kbEnter);

ok.ShowButton();
mouse_show();

EVENT event;

go:

event=_GetEvent();

if(ok.ProcessEvent(&event)==PRESSED) {
					message.DeleteWindow();
					return MB_OK;
				      }
goto go;

VideoSetColor(bc);
return 0;
}



  int getkey(void)
{
_AX=0;
asm int 16h;
return _AX;
}

int gprintf( int xloc, int yloc, char *fmt, ... )
{
  va_list  argptr;
  char str[140];
  int cnt;

  va_start( argptr, fmt );

  cnt = vsprintf( str, fmt, argptr );
  VideoOutTextXY( xloc, yloc, str );

  va_end( argptr );

  return( cnt );
}

int Text8f( int xloc, int yloc,int fc, int bc, char *fmt, ... )
{
  va_list  argptr;
  char str[140];
  int cnt;

  va_start( argptr, fmt );

  cnt = vsprintf( str, fmt, argptr );
  Text8( xloc, yloc, fc, bc, str );

  va_end( argptr );

  return( cnt );
}


int getfreemem(void)
{
void *k[640];
int kb=0;

while((k[kb]=malloc(1024))!=0) kb++;

for(int i=0; i<kb; i++ ) {

    free(k[i]);
			 }

return kb;
}

    char * getfile(char *path,char *name,char *nn)
{
int flag;
struct ffblk files;
void  *save;
int i,j,done,curr;
int number;
int realnum,bak;
char lpath[20];
char *dirs[400];
char  str[400][20];

int key;
int counter;

lpath[0]=0;
strcat(lpath,path);

WINDOW f(-1,-1,260,160,name,DLG_FRAME);

f.ShowWindow();
InputLine il(f.x+130,f.y+30,lpath,12, kbAltF);
BUTTON ok(f.x+20,f.y+135, 80, 20, "&OK",kbEnter);
BUTTON cancel(f.x+160,f.y+135, 80, 20, "&Cancel",kbEsc);

mouse_show();
il.Show();
ok.ShowButton();
cancel.ShowButton();
f.SetTextColor(0);
f.UString(20,30+5-13, "&Filemask:");


START:

for(int ii=0; ii<400;  ii++)
for(int zz=0; zz<20;  zz++)
 str[ii][zz]=0;

realnum=0;
i=0;
done=0;
curr=0;

done=findfirst(lpath,&files,0xff);
strlwr(files.ff_name);
strcat(str[0],files.ff_name);
files.ff_name[0]=0;

while(!done)
{
   curr++;

   done=findnext(&files);
   strlwr(files.ff_name);
   strcat(str[curr], files.ff_name);
   files.ff_name[0]=0;
}
for(int kk=0; kk<curr; kk++) dirs[kk]=&str[kk][0];

LIST list(f.x+8,f.y+60,6,curr,30,dirs);
list.Show();
EVENT event;
begin:

event=_GetEvent();

if(il.ProcessEvent(&event)==0) goto START;

if((ok.ProcessEvent(&event))==PRESSED)
{

f.DeleteWindow();
nn[0]=0;
strcat(nn,dirs[list.curr]);
path[0]=0;
strcat(path,lpath);
return (char *) 1;

}

if((cancel.ProcessEvent(&event)==PRESSED)) goto ex;

list.ProcessEvent(&event);

goto begin;

ex:
f.DeleteWindow();

//if(path[strlen(path)+2]==0)
//{
path[0]=0;
strcat(path,lpath);
//}

return (char *) 0;
}


void makeextention(char *av,char *e)
{
int flags;
char drive[10], dir[100], file[20], ext[10];

drive[0]=0;
dir[0]=0;
file[0]=0;
ext[0]=0;

flags=fnsplit(av, drive, dir, file, ext);

strupr(av);

if(strlen(ext)==0) {

strcat(av,e);

		}

else return;
}

int MessageBoxf(int st,char *fmt, ... )
{
  va_list  argptr;
  char str[200];
  int cnt;

  va_start( argptr, fmt );

  cnt = vsprintf( str, fmt, argptr );
  WinMessageBox("Message",str, st);
  va_end( argptr );

  return( cnt );
}

void makeextension(char *name,char *extension)
{
char drive[MAXDRIVE];
char dir[MAXDIR];
char file[MAXFILE];
char ext[MAXEXT];
int flags;

strupr(name);

flags=fnsplit(name,drive,dir,file,ext);

if(strlen(ext)==0)
 strcat(name,extension);

}