#include "string.h"
#include "sprite.h"
#include "io.h"
#include "fcntl.h"
#include "stdio.h"
#include "stdlib.h"
#include "dos.h"
#include "conio.h"

typedef struct _SLIB_HDR_ {
char SL[2];
char Descr[20];
int  Number; // Max number;
} SLIB_HDR;


typedef struct _SLIB_ITEM_ {
char FileName[13];
} SLIB_ITEM;

SLIB_HDR   sl;
SLIB_ITEM item;

char dospath[100]={ 0 };

FILE *snames;

void main(int argc,char **argv)
{
void *buf;
int h,h2,h3,i;
long len;
int off=80;
int moveadd;
long ifrom;

if(argc==1)
{
puts("MOVE Utility Version 1.0 BY Alex Chudnovsky");
puts("Usage: MOVE.EXE SPRLIB1.SL SPRLIB2.SL");
return;
}

strupr(argv[1]);
strupr(argv[2]);

buf=malloc(32000);

if(buf==0)
{
puts("Error: Out of memory!");
return;
}

if((strcmp(argv[1],argv[2]))==0)
{
puts("Error: Given names are the same!");
return;
}


if((h=_open(argv[1],O_RDWR))==-1)
{
printf("Error: Unable to open sprite library: %s;\n\r",argv[1]);
return;
}

if((h2=_creat(argv[2],FA_ARCH))==-1)
{
printf("Error: Unable to creat sprite library: %s;\n\r",argv[2]);
close(h);
return;
}

if(_read(h,&sl,sizeof(SLIB_HDR))==-1)
{
FileErr:
puts("File error!");
return;
}

ifrom=sizeof(SLIB_HDR);

printf("Processing number is %d;\n",sl.Number);
printf("Working (from offset=%d)",off);

_write(h2,&sl,sizeof(SLIB_HDR));

for(i=0; i<sl.Number; i++)
{
item.FileName[0]=0;
strcat(item.FileName,"__NONAME.SPR");
lseek(h2,ifrom+i*sizeof(SLIB_ITEM),SEEK_SET);
_write(h2,&item,sizeof(SLIB_ITEM));
}

for(i=0; i<270; i++)
{

if(i<off)
{
_read(h,&item,sizeof(SLIB_ITEM));
lseek(h2,ifrom+i*sizeof(SLIB_ITEM),SEEK_SET);
_write(h2,&item,sizeof(SLIB_ITEM));
continue;
}

_read(h,&item,sizeof(SLIB_ITEM));
lseek(h2,ifrom+(i+150)*sizeof(SLIB_ITEM),SEEK_SET);
_write(h2,&item,sizeof(SLIB_ITEM));
}


close(h);
close(h2);
}