#include "master.h"

char *SprEditor="Sprite Editor v2.01";

extern unsigned _stklen=40000;

int CurrentSave=3;
int exitprompt=0;
char savename[15]={ 0 };

int SaveType=1;
char *mitems[]={

"&Load               F3",
"&Save               F2",
"",
"E&xit            Alt-X",
"",
"&Browse SprLib  Alt-F2",
};

int  mvalues[]={
F3,
F2,
0,
ALT_X,
0,
kbAltF2,
0,
kbShiftF9

};

char *mitems2[]={

"&Set                 SPACE",
"&Reset                 DEL",
"&Clear all          Alt-F8",
"&Fill                   F9",
"C&hange sizes      Ctrl-F5",
"&Replace colors     Alt-F6",
"Sh&ow char          Alt-F7",
"Sc&ale x2           Alt-F9",
"",
"Clipboard Copy   Ctrl-Ins",
"Clipboard Paste Shift-Ins"

};

int  mvalues2[]={
ENTER,
DEL,
kbAltF8,
F9,
CTRL_F5,
kbAltF6,
kbAltF7,
kbAltF9,
0,
0,
0
};

// Non significant values:
VSCROLL ColorScroll(0,0,0);

char *mitems3[]={

"&Palette setup",
"&Load palette",

};

int  mvalues3[]={
kbAltP,
kbAltL,
kbCtrlM,
kbCtrlS
};

MENU menus[]={

{ " &File",    mitems,  mvalues,   kbAltF, 6, 22 },
{ " &Edit",    mitems2, mvalues2,  kbAltE, 11,26 },
{ " &Options", mitems3, mvalues3,  kbAltO, 2, 16 },

};

int _cx=5,_cy=5;

MENUBAR menu(1, MENU_BASE, 3, menus);

int maxx,maxy;

int bottomx;      // Bottom border off panel
int bottomy;

int smallbase;    // X-coordinate, where small box located

int cellx=5;
int celly=5;
int smallx,smally=50;
int LBase=10;
int bigx=20,bigy=50;
int vmode;
int colsize=15;

int show=0;
int posx=0;
int posy=0;
unsigned prevcolor;
int direction=1;  // 0 - no traces, 1-yes
int autodel=1;
int editflag=0;
int saveflag=0;
char loadname[20];
int startsizex=16,startsizey=16;
int __maxx,__maxy;
int ac;


int editx,edity;
int curx,cury,curcolor=15;

// Base for fields
int maskbase;

char filename[64];

// FOR Quick Start:

int quickstart=0;
int whatstart=0;
int debug=0;
int modestart=0,_vmode=0;
int _copyright=1;
int vgamode;


char *EditData;

    void setnew(int x,int y,int operation)
{
mouse_hide();
char ReDraw=GetValue(posx,posy);

if(ReDraw!=255) set(posx,posy,ReDraw);
else            reset(posx,posy);

posx=x;
posy=y;

ReDraw=GetValue(posx,posy);

if(ReDraw!=255) VideoSetColor(~(GetValue(posx,posy)));
else            VideoSetColor(15);

VideoRectangle( LBase+posx*cellx, 50+posy*celly, LBase+posx*cellx+cellx-1, 50+posy*celly+celly-1);
VideoSetColor(15);

showxy();
mouse_show();
return;
}

  void fillicon(void)
{
int a,b;

 VideoSetFillStyle(SOLID_FILL, curcolor);
 VideoBar(LBase,50,LBase+editx*cellx-1,50+edity*celly-1);
 VideoBar(smallx, 50, smallx+editx-1, 50+edity-1);

  VideoSetActivePage(1);
  VideoEraseScr(0);
  VideoSetActivePage(0);
  setnew(curx,cury);
}


       void drawedit(int newx,int newy)
{
 int i,k,j,x,y;
 char string[25];

 mouse_hide();

 curx=cury=0;
 editx=newx;
 edity=newy;
 smallx=LBase+editx*cellx+20;

 VideoSetFillStyle(SOLID_FILL, BLACK);
 VideoBar(5,48,VideoGetMaxX()-45, bottomy-18);

  clearfield();
  setnew(0,0);

  VideoSetColor(WHITE);
  showsize(newx,newy);

 smallx=LBase+editx*cellx+20;

 VideoRectangle(LBase-1,  49, LBase+cellx*editx, 50+celly*edity);
 VideoRectangle( smallx-1, 49, smallx+editx, 50+edity);

 for(y=0; y<newy; y++) {
 for(x=0; x<newx; x++) {
  VideoPutPixel( LBase+x*cellx, 50+y*celly,LIGHTCYAN);
  SetValue(x,y,255);
		   }
		   }

// For correct saving...
CurrentSave=3;

 mouse_show();
}

      void set(int x,int y,char c)
{
 VideoSetFillStyle(SOLID_FILL, c);
 VideoBar( LBase+x*cellx, 50+y*celly, LBase+x*cellx+cellx-1, 50+y*celly+celly-1);
 VideoPutPixel(smallx+x,50+y,c);
 SetValue(x,y,c);
}


      void reset(int x,int y)
{
 VideoSetFillStyle(SOLID_FILL, 0);
 VideoBar( LBase+x*cellx, 50+y*celly, LBase+x*cellx+cellx-1, 50+y*celly+celly-1);
 VideoPutPixel(smallx+x,50+y,0);
 VideoPutPixel( LBase+x*cellx, 50+y*celly,LIGHTCYAN);

 SetValue(x,y,255);
}


void iconsave(void)
{
WINDOW s(-1,-1,300,140,"Save",DLG_FRAME);

s.ShowWindow();

InputLine il(s.x+170,s.y+25,savename,12, kbAltF);

BUTTON ok(s.x+10,s.y+110,80,20,"&OK",kbEnter);
BUTTON cancel(s.x+210,s.y+110,80,20,"&Cancel",kbEsc);
BUTTON options(s.x+110,s.y+110,80,20,"&Options",kbAltO);

ok.Show();
cancel.Show();
options.Show();
il.Show();
s.SetTextColor(0);
s.UString(20,25+5-13, "&Filename to save:");

mouse_show();

EVENT event;

start:

event.keyboard=kbAltF;
il.ProcessEvent(&event);

go1:

event=_GetEvent();

il.ProcessEvent(&event);

if( (cancel.ProcessEvent(&event))==PRESSED) {
					s.DeleteWindow();
					return;

					     }

if((options.ProcessEvent(&event))==PRESSED) { }

if( (ok.ProcessEvent(&event))!=PRESSED) goto go1;

makeextension(savename,".SPR");

s.DeleteWindow();

SaveSprite(savename);

}

  void showxy(void)
{
 Text8f(120,bottomy-10,15,0,"Coord %d:%d   ",curx,cury);
}

  void showsize(int x,int y)
{
 Text8f(9,bottomy-10,15,0, "Size %d:%d  ",x,y);
}


 void clearfield(void)
{
VideoSetFillStyle(SOLID_FILL, 255);
VideoBar(smallx, 50, smallx+editx, 50+edity);
VideoSetFillStyle(SOLID_FILL, 0);
}

char LoadExt[40];
//char Empty[20];

      void iconopen(void)
{
int st;
char name[20];

name[0]=0;

  if((getfile(LoadExt,"Load",name))==0) {  return; }

savename[0]=0;
strcat(savename,name);
      iconload(name);
}

 void changecolor(int option)
{
int col,x,c;
int mx=VideoGetMaxX();
c=curcolor;

col=curcolor;
if(option!=0) goto go;

if(option>=20) {

 VideoSetColor(curcolor);
 VideoRectangle(mx-40,45+curcolor*colsize, mx-25, 45 + colsize + curcolor * colsize);

 curcolor=option-20;

 VideoSetColor(~curcolor);
 VideoRectangle(mx-40,45+curcolor*colsize, mx-25, 45 + colsize + curcolor * colsize);
 VideoSetColor(0);

 return;

	       }


go:

  VideoSetFillStyle(SOLID_FILL, 0);
  VideoSetColor(WHITE);

if(option!=0) {

switch(option) {

case GREY_PLUS: goto up;
default:        goto down;
}

}


begin: switch(getkey()) {

up:

  case UP:
	 VideoSetColor(curcolor);
	 VideoRectangle(mx-40,45+curcolor*colsize, mx-25, 45 + colsize + curcolor * colsize);
	 if(curcolor!=0) { curcolor--; } else   { curcolor=15; }
	 VideoSetColor(~curcolor);
	 VideoRectangle(mx-40,45+curcolor*colsize, mx-25, 45 + colsize + curcolor * colsize);
	 VideoSetColor(0);      if(option!=0){
	  return;
					 }
	  goto begin;

down:

  case DOWN:
	 VideoSetColor(curcolor);
	 VideoRectangle(mx-40,45+curcolor*colsize, mx-25, 45 + colsize + curcolor * colsize);
	 if(curcolor!=15) { curcolor++; } else   { curcolor=0; }
	 VideoSetColor(~curcolor);
	 VideoRectangle(mx-40,45+curcolor*colsize, mx-25, 45 + colsize + curcolor * colsize);
	 VideoSetColor(0);           if(option!=0) {
	 return;
					       }
	 goto begin;


  case ENTER:  break;

  case ESC:
	 VideoSetColor(curcolor);
	 VideoRectangle(mx-40,45+curcolor*colsize, mx-15, 45 + colsize + curcolor * colsize);
	 curcolor=c;
	 VideoSetColor(curcolor);
	 VideoRectangle(mx-40,45+curcolor*colsize, mx-15, 45 + colsize + curcolor * colsize);
	 VideoSetColor(0);

	 return;                       // Function exit


 default: goto begin;

};
 col+=0;

}

 void copyright(void)
{
About();
}


void processerror(int err)
{
}


void ShowMem(void)
{
// ****** For DEBUG mode only ******
if(debug!=DEBUG) return;
mouse_hide();

char buf[5];
buf[0]=0;
itoa(getfreemem(), buf, 10);

Text8(248+4*8,bottomy-10,15,0,buf);

mouse_show();
}


void About(void)
{

WINDOW about(-1,-1,200,140,"About",DLG_FRAME);

about.ShowWindow();
about.SetTextColor(BLACK);
about.Print(-1,10,"Game Development System");
about.Print(-1,20,"Version 1.22");

about.Print(-1,40,"Copyright (C) 1993/94");
about.Print(-1,50,"Mythical Software Group");

about.Print(-1,70,"Programming:");
about.Print(-1,80,"Alex Chudnovsky",LIGHTBLUE);

BUTTON ok(VideoGetMaxX()/2-200/2+70, VideoGetMaxY()/2-70+110,60,20,"&OK",kbEnter);

ok.ShowButton();
mouse_show();

EVENT event;

go:

event=_GetEvent();

if(ok.ProcessEvent(&event)==PRESSED) {
					about.DeleteWindow();
					return;
				      }
goto go;

}


void changesize(void)
{
mouse_show();
WINDOW chsize(-1,-1,260,180,"Change sizes",DLG_FRAME);
chsize.ShowWindow();
int tx,ty;
tx=editx;
ty=edity;
_cx=cellx;
_cy=celly;

chsize.SetTextColor(BLACK);
FRAME fr1(chsize.x+5,chsize.y+20,190+60,60," Edit box size ");
NUMBER x(&tx,chsize.x+15,chsize.y+30,1,maxx);
NUMBER y(&ty,chsize.x+15,chsize.y+55,1,maxy);

FRAME fr2(chsize.x+5,chsize.y+90,190+60,60," Cell size ");
NUMBER cx(&_cx,chsize.x+15,chsize.y+100,0,6);
NUMBER cy(&_cy,chsize.x+15,chsize.y+125,0,6);

BUTTON ok(chsize.x+20,chsize.y+155, 80, 20, "&OK",kbEnter);
BUTTON cancel(chsize.x+160,chsize.y+155, 80, 20, "&Cancel",kbEsc);

fr1.Show();
fr2.Show();
	     mouse_hide();
chsize.Print(100,25,"On X");
chsize.Print(100,50,"On Y");
chsize.Print(100,95,"On X");
chsize.Print(100,120,"On Y");
	     mouse_show();
x.Show();
y.Show();
cx.Show();
cy.Show();

ok.ShowButton();
cancel.ShowButton();

EVENT event;
go:

event=_GetEvent();
x.ProcessEvent(&event);
y.ProcessEvent(&event);

if((cx.ProcessEvent(&event))!=-1)
{
x.max=mx();
*x.value=x.max;
x.Show();
}

if((cy.ProcessEvent(&event))!=-1)
{
y.max=my();
*y.value=y.max;
y.Show();
}

if(ok.ProcessEvent(&event)==PRESSED)
{
chsize.DeleteWindow();
mouse_hide();

maxx=x.max;
maxy=y.max;
cellx=_cx;
celly=_cy;

editx=tx;
edity=ty;

drawedit(editx,edity);
mouse_show();
return;
}


if(cancel.ProcessEvent(&event)==PRESSED)
{

chsize.DeleteWindow();
return;

}

if(event.keyboard!=ESC) goto go;

chsize.DeleteWindow();

}


int mx(void)
{
return ((VideoGetMaxX()-LBase-60)/(_cx+1) );
}

int my(void)
{
return ( (VideoGetMaxY()-65)/_cy);
}

// On second vpage:
int  GetMaskXY(int x,int y)
{
int i=VideoGetPixel(smallx+x,50+y);

return i;
}


void SetMaskXY(int x,int y,int value)
{
if(value==15) VideoPutPixel(smallx+x,50+y,255);
}

int AdjustSizesTo(int vx,int vy)
{
int __cx,__cy,k;

if((vx<maxx) && (vy<maxy))
{
mouse_hide();
drawedit(vx,vy);
mouse_show();
return 0;
}

int mxy=VideoGetMaxY()-20;

__cx=cellx;
__cy=celly;

for(k=5; k>0; k--)
{
cellx=k;
_cx=k;
if(mx()>vx) goto l1;
}

_cx=__cx;
cellx=_cx;
return -1;

l1:

for(k=5; k>0; k--)
{

celly=k;
_cy=k;
if(my()>vy) goto l2;

}

_cx=__cx;
cellx=_cx;

_cy=__cy;
celly=_cy;

return -1;

l2:

maxx=vx;
maxy=vy;
drawedit(vx,vy);
return 0;
}

int xchgDest,xchgSour;

void ExchangeColors(void)
{
int maxc=16;

WINDOW c(-1,-1,280,180,"Replace Colors",DLG_FRAME);

if(_VGA!=0)
 maxc=255;

NUMBER d(&xchgDest,c.x+20,c.y+30,-1,maxc+1,1);
NUMBER s(&xchgSour,c.x+210,c.y+30,-1,maxc+1,1);

BUTTON ok(c.x+20,c.y+150, 80, 20, "&OK",kbEnter);
BUTTON cancel(c.x+180,c.y+150, 80, 20, "&Cancel",kbEsc);

c.ShowWindow();

ok.Show();
cancel.Show();
d.Show();
s.Show();

VideoSetFillStyle(0,xchgDest);
VideoBar(c.x+20,c.y+70,c.x+20+16,c.y+70+16);

VideoSetFillStyle(0,xchgSour);
VideoBar(c.x+220,c.y+70,c.x+220+16,c.y+70+16);

VideoSetColor(0);
VideoRectangle(c.x+16,c.y+70-4,c.x+20+16+4,c.y+70+16+4);
VideoRectangle(c.x+216,c.y+70-4,c.x+220+16+4,c.y+70+16+4);

c.SetTextColor(0);
c.Print(15,85,"Color to replace;");
c.Print(190,85,"New color;");
c.Print(5,100,"Last color is a transparent color;");

EVENT event;

go:

event=_GetEvent();

if(event.keyboard==F2)
{
if(xchgSour==0) xchgSour=255;
else            xchgSour=0;

s.Show();
VideoSetFillStyle(0,xchgSour);
VideoBar(c.x+220,c.y+70,c.x+220+16,c.y+70+16);

goto go;
}

if(event.keyboard==F1)
{
if(xchgDest==0) xchgDest=255;
else            xchgDest=0;
d.Show();
VideoSetFillStyle(0,xchgDest);
VideoBar(c.x+220,c.y+70,c.x+220+16,c.y+70+16);

goto go;
}


if((d.ProcessEvent(&event))!=-1)
{

VideoSetFillStyle(0,xchgDest);
VideoBar(c.x+20,c.y+70,c.x+20+16,c.y+70+16);

}

if((s.ProcessEvent(&event))!=-1)
{

VideoSetFillStyle(0,xchgSour);
VideoBar(c.x+220,c.y+70,c.x+220+16,c.y+70+16);

}

if(ok.ProcessEvent(&event)==PRESSED)
{

if(xchgDest==xchgSour)
{

MessageBox("Colors are the same!",1);

goto go;

}

c.DeleteWindow();
int counter=0;
int whatcol;

if(VGA==0) whatcol=16;
else       whatcol=255;
for(int k=0; k<edity; k++)
for(int j=0; j<editx; j++)
{

if(GetValue(j,k)==xchgDest)
{

counter++;

if(xchgSour!=whatcol)
{ set(j,k,xchgSour);    }
else
{ reset(j,k);  }

}

}

if(counter!=0) {
int tmp=xchgSour;
xchgSour=xchgDest;
xchgDest=tmp;
	       }

VideoSetFillStyle(0,0);
MessageBoxf(0,"Done %d changes.",counter);
return;

}

if(cancel.ProcessEvent(&event)==PRESSED)
{

goto ex;

}

goto go;

ex:

c.DeleteWindow();
VideoSetFillStyle(0,0);

}

int GetValue(int x,int y)
{
return EditData[x+y*editx];
//int k=VideoGetPixel(smallx+x,50+y);
//return k;
}

void SetValue(int x,int y,char c)
{
//VideoPutPixel(smallx+x,50+y,c);
EditData[x+y*editx]=c;
}

char ucShowChar;
void ShowChar(void)
{

if((editx!=8) || (edity!=8))
{
if(yesno("Show Char","Sizes are not valid. Make them?")==1) return;
}
editx=8;
edity=8;
drawedit(8,8);

char ch[2];
ch[1]=0;
ch[0]=ucShowChar;

WINDOW s(-1,-1,200,100,"Show Char",DLG_FRAME);

s.ShowWindow();

InputLine il(s.x+80,s.y+45,ch,1, kbAltF);
il.Show();

EVENT e;
e.keyboard=kbAltF;

go:
il.ProcessEvent(&e);

s.DeleteWindow();

if(ch[0]==0) return;

ucShowChar=ch[0];

int bc=VideoGetColor();
VideoSetColor(curcolor);
VideoOutTextXY(smallx,50,ch);
char val;

if(_VGA!=0)
{
for(int k=0; k<8; k++)
for(int j=0; j<8; j++)
{
val=GetMaskXY(j,k);

if(val!=255) set(j,k,val);

}
}

VideoSetColor(bc);
}

void ScaleX2(void)
{
int x,y;

char *mem=(char *) malloc(editx*edity);

if(mem==0) { MessageBox("Not enough memory",1); return; }

mouse_hide();
for(y=0; y<edity; y++)
for(x=0; x<editx; x++)
{
mem[x+y*editx]=GetValue(x,y);
}
mouse_show();

 if(AdjustSizesTo(editx*2,edity*2)!=0)
 {
 MessageBox("Result sizes too large.");
 free(mem);
 return;
 }

mouse_hide();
char val;

for(y=0; y<edity/2; y++)
for(x=0; x<editx/2; x++)
{
val=mem[x+y*editx/2];

if(val==255)
{
reset(x*2,y*2+1);
reset(x*2+1,y*2+1);
reset(x*2+1,y*2);
reset(x*2,y*2);
}
else
{
set(x*2,y*2+1,val);
set(x*2+1,y*2+1,val);
set(x*2+1,y*2,val);
set(x*2,y*2,val);
}

}

mouse_show();
free(mem);
}


void Turn90(void)
{
int x,y;

char *mem=(char *) malloc(editx*edity);

if(mem==0) { MessageBox("Not enough memory",1); return; }

mouse_hide();
for(y=0; y<edity; y++)
for(x=0; x<editx; x++)
{
mem[x+y*editx]=GetValue(x,y);
}
mouse_show();

 if(AdjustSizesTo(edity,editx)!=0)
 {
 MessageBox("Result sizes too large.");
 free(mem);
 return;
 }

mouse_hide();
char val;

for(y=0; y<edity; y++)
for(x=0; x<editx; x++)
{
val=mem[y+(editx-x-1)*edity];

if(val==255) reset(x,y);
else         set(x,y,val);

}

mouse_show();
free(mem);
}


int SaveSprite(char *name)
{
int sprsize=editx*edity;
char *buffer;
int handle;

buffer=(char *)malloc(sprsize);

if(buffer==0)
{
MessageBox("Out of memory",1);
return -1;
}

if((handle=_creat(name,FA_ARCH))==-1)
{
  MessageBoxf(1,"Unable to creat file '%s'",name);
  return -1;
}

SPR_HDR Spr;

Spr.NK[0]= 'N';
Spr.NK[1]= 'K';
Spr.Type=CurrentSave; //
Spr.VideoMode=vmode;
Spr.DataLen=sprsize;
Spr.SizeX=editx;
Spr.SizeY=edity;
Spr.Version=VERSION;
Spr.MaskLen=0;

if((_write(handle,&Spr,sizeof(Spr)))==-1)
{
writeerr:
  MessageBoxf(1,"Unable to write data to '%s'",name);
  return -1;
}
if((_write(handle,EditData,Spr.DataLen))==-1)  { goto writeerr; }

close(handle);
return 0;
}

    void GDS_LoadSprite(char *name);
int LoadRetCode;
void iconload(char *name)
{
LoadRetCode=0;
GDS_LoadSprite(name);

if(LoadRetCode==-1)  MessageBoxf(1,"Open err: '%s'",name);
else { loadname[0]=0; strcat(loadname,name); }
}

    void GDS_LoadSprite(char *name)
{
int st,handle=0;
char c;
int x,y;
int sprsize;

SPR_HDR Spr;

if((handle=open(name,O_RDWR))==-1)
{
LoadRetCode=-1;
//  MessageBoxf(1,"Unable to open file '%s'",name);
  return;
}

if((_read(handle, &Spr, sizeof(Spr)))==-1)
{
  MessageBox("Unable to read file",1);
  close(handle);
  return;
}

if((Spr.NK[0]!='N') || (Spr.NK[1]!='K'))
{
  MessageBox("Incorrect sprite file format",1);
  close(handle);
  return;
}

  if(Spr.VideoMode!=vmode) {

  switch(yesno("Sprite Editor", "Conflict sprite video modes. Proceed?")) {
    case 1: close(handle); return;
    case 0: break;

     };
   }

if(Spr.Version!=VERSION) {

  switch(yesno("Sprite Editor","Incorrect sprite version. Proceed?")) {
    case 1: close(handle);    return;

    case 0: break;

     };
   }


 if(AdjustSizesTo(Spr.SizeX,Spr.SizeY)!=0)
 {
 if((Spr.SizeY>maxy) || (Spr.SizeX>maxx))
 {
  switch(yesno("Sprite Editor","Sprite's sizes too big. Proceed?")) {
    case 1: close(handle); return;

    case 0: break;
 };

 }

 }

sprsize=Spr.DataLen;

// VGA Loading:
if(Spr.Type==3 || Spr.Type==80)
{
if(Spr.SizeX*Spr.SizeY!=Spr.DataLen)
{
MessageBoxf(0,"Sprite Warning:||~ DataLen=%d,|~ Must be: %d",Spr.DataLen,Spr.SizeX*Spr.SizeY);
}

mouse_hide();
char val;
_read(handle,EditData,Spr.DataLen);

for(y=0; y<Spr.SizeY; y++)
{
for(x=0; x<Spr.SizeX; x++)
{
val=EditData[x+y*Spr.SizeX];
if(val!=255) set(x,y,val);
else         reset(x,y);
}
}

mouse_show();
goto end;
}

end:

  close(handle);
  return;
} // end of Load

