/*

	Animation Routines Header File Version 1.0 
	Copyright (C) Mythical Software Group 

	Programming: Alex Chudnovsky, (Frodo)

*/

#define MAX_SPRITES  512
#define ON  0
#define OFF 1

typedef struct __SPR_ITEM__ {

void *data,*mask;
char flag;

} SPR_ITEM;

typedef struct __SCR_ITEM__ {

int SpriteNum;
int x,y;
int CacheHandle;

} SCR_ITEM;

void UpdateScreen(void);
void SetAutoUpdateFreq(int);
void EnableAutoUpdate(void);
void DisableAutoUpdate(void);

void InitUpdateScreen(void);

// Sprite Routines:

int  PlaceSpriteAt(void);        // Parametres not defined yet...
void DeleteSprite(int plane);    // Plane to delete sprite...  
