#define OK 0
#define SHIT 1
#define UP 18432
#define DOWN 20480
#define RIGHT 19712
#define LEFT 19200
#define PGUP 18688
#define PGDOWN 20736
#define END 20224
#define HOME 18176
#define GREY_PLUS 20011
#define GREY_MINUS 18989
#define ALT_I 5888
#define ALT_E 4608
#define ALT_O 6144
#define ALT_F 8448

#define CTRL_M 12813
#define F1 15104
#define F2 15360
#define F3 15616
#define F4 15872
#define F5 16128
#define F6 16384
#define F7 16640
#define F8 16896
#define F9 17152
#define F10 17408

#define ESC       283
#define ENTER     7181
#define DEL       21248
#define SHIFT_DEL 21294
#define TAB       3849
#define SPACE     14624
#define CTRL_F5   25088
#define ALT_X     11520
#define CTRL_Q    4113
#define DIV       13615
#define MUL       14122
#define CTRL_I    5897


#define LEFT_BUTTON 1
#define RIGHT_BUTTON 2
#define MIDDLE_BUTTON 4

#define PCXMEM 10000

#define VERSION 10

#define DEBUG        1
#define NOMOUSE     -1
#define NOCOPYRIGHT  1
#define MODE_1      '1'
#define MODE_2      '2'
#define MODE_3      '3'
#define MODE_4      '4'

#define GREDITOR     2

struct SPRITE_ITEM;
struct file;

#define PRESSED 0
#define NOT_PRESSED 1

typedef unsigned char BYTE;
typedef unsigned long DWORD;
typedef unsigned int  WORD;


struct MouseEvent {

unsigned int x;
unsigned int y;
unsigned int buttons;
char type;

		  };



typedef struct tagEVENT {

MouseEvent mouse;
unsigned int keyboard;

} EVENT;



int  gettextxy(int x,int y,char *s,int len);
void help(void);
void fillicon(void);
void clearsysmes(void);
void changename(void);
void setnew(int x,int y,int op=0);
void changesize(void);
void changecolor(int);
int getkey(void);
void setcol(void);
void showsize(int x,int y);
void showxy(void);

void edit(void);
void drawedit(int,int);
void set(int x,int y,char c);
void reset(int x,int y);
void clearfield(void);
void iconopen(void);
void iconload(char *name);
void * loadsprite(char *name);
void iconsave(void);
void copyright(void);

void MessageBox(char *,int=0);
void shownumber(void);
char * getfile(char *path, char *name,char *nn);         // Path with Mask
void showfile(struct file n,int c, int i );
void help(void);
void processerror(int);


int gprintf( int xloc, int yloc, char *fmt, ... );
void setint24(void);
int int24(int errval,int ax,int bp,int si);

void mouse_init(void);
void mouse_hide(void);
void mouse_show(void);
struct MouseEvent mouse_query(void);
EVENT getevent(void);
void example(void);
void ShowMem(void);
void mouse_set_window(int xmin, int xm, int ymin, int ym);
void About(void);
EVENT _GetEvent(void);

struct icon_header {
   char nk[2];
   char version;
   char type;
   int heigth;
   int length;
   char mode;    //  0x10
   int size;     // size of the ICON in putimage brains
};
