/*

  EGA Graph Screen Routines Version 1.0
  Copyright (C) Mythical Software Group

*/

#define BYTEOF(x,y) ((y)*BytesPerLine+((x)/8))
#define BITOF(x)  (0x80>>((x)&0x07))        // 000x0000

#define GDC              0x3CE

#define GDCReset         0x00
#define GDCEnable        0x01
#define GDCColorCompare  0x02
#define GDCDataRotate    0x03
#define GDCReadMapSel    0x04
#define GDCMode          0x05
#define GDCMisc          0x06
#define GDCColorDC       0x07
#define GDCBitMask       0x08

#define SETREG(c,r,v) outportb((c),(r));\
		      outportb((c+1),(v))

#define SETMASK(m)       SETREG(GDC,GDCBitMask,(m))
#define SetReadPlane(m)  SETREG(GDC,GDCReadMapSel,(m));
#define SetWritePlane(m) SETREG(0x3c4,2,1<<(m));

void EGAGetImage8(int,int,int,int,char *);
void EGAPutImage8(int,int,int,int,char *);