/*

	      Font Utility Header File Version 1.0
	      Copyright (C) Mythical Sotware Group

*/

#define FONT_VERSION 1
#define SPRITE_VERSION 5

typedef struct tagFONT_HEADER {

char LM[8];         // Signature
char version;
unsigned xlen;
unsigned ylen;
unsigned imagesize; // In bytes
int vmode;

} FONT_HEADER;


typedef struct tagFONT_CHAR_TABLE {

char symbols[256];

} FONT_CHAR_TABLE;


// Sprite Header
typedef struct _SPRITE_HEADER {

   char nk[2];
   char hobbits[38];
   int version;
   char type;
unsigned   char heigth;
unsigned   char length;
   char mode;    //  0x10
   char template;  // 0 -- on, 1 -- off
   char iconname[9];
   int size;     // size of the ICON in putimage brains

} SPRITE_HEADER;

void help(void);
void creatfont(int,char **);
void FontInfo(int,char **);
void AddChar(int,char **);
void DeleteChar(int,char **);
void error(char *);
void makeextention(char *,char *);
int getyn(void);
int getfreeplace(void);  // Returns absolute place of new symbol data
int charnum(void); // Number defined chars in font
void ShowChar(int,char **);


// Font functions:

void CharOutXY(int , int, char);
void StringOutXY(int , int, char *);
void LoadFont(char *);
