#include "stdlib.h"
#include "stdio.h"
#include "conio.h"
#include "time.h"
#include "string.h"
#include "fcntl.h"
#include "dos.h"
#include "stdarg.h"
#include "ctype.h"
#include "process.h"
#include "dir.h"
#include "io.h"
#include "alloc.h"
#include "bwg.h"

#include "video.h"
#include "fonts.h"

void VGAOutByteXY(int x,int y,char b,char color);

 VideoOutByteXY(int,int, char, char);

int ROM_FONT::LoadFont(void)
{

if(FontMem!=0)
{

printf("FONTS->LoadFont: Font '%s' already loaded\n\r",FileName);
getch();
return 1;

}

FontMem=(char *) malloc(256*Heigth);
int handle;

if(FontMem==0)
{

printf("FONTS->LoadFont: Not enough memory for font '%s'; Need: %dbytes\n\r",FileName,256*Heigth);
getch();
return 1;

}

if ((handle = _open(FileName, O_RDONLY)) == -1)
{

   printf("Error: Unable to open 8x%d font: '%s';\n\r",Heigth,FileName);
   getch();
   return 1;

}


if((_read(handle,FontMem,256*Heigth))==-1)
{

   printf("Error: Unable to read 8x%d font data: '%s';\n\r",Heigth,FileName);
   getch();
   return 1;

}

return 0;

}


void  ROM_FONT::Print(int x,int y, char color, char *s)
{
if(FontMem==0) return;

int c=0;
mouse_hide();

while(s[c]!=0)
{ CharXY(x+8*c,y,color,s[c]); c++; }

mouse_show();
}

void  ROM_FONT::CharXY(int x,int y,char col,char s)
{
char t;
for(int i=0; i<Heigth; i++)
{

t=(char) FontMem[s*Heigth+i];
VGAOutByteXY(x,y+i, t, col);

}

}