/*

      Object File Version 1.03

*/

#include "graphics.h"
#include "time.h"
#include "string.h"
#include "fcntl.h"
#include "dos.h"
#include "stdarg.h"
#include "ctype.h"
#include "process.h"
#include "dir.h"
#include "io.h"
#include "pcxlib.h"
#include "alloc.h"
#include "stdio.h"
#include "conio.h"

#include "errno.h"
#include "stddef.h"
#include "stdlib.h"

#include "gamekit.h"
#include "objects.h"

#include "defines.h"
#include "tkeys.h"
#include "bwg.h"

#include "video.h"

int MessageBoxf(int st,char *fmt, ... );

#define MB_OK     0
#define MB_CANCEL 1

EVENT _GetEvent(void);
void  ShowMem(void);
void  clearevent(EVENT *);
void  HideCursor(int,int);
void  ShowCursor(int,int);
EVENT _GetMouseEvent(void);
int   GetVideoMode(void);
char  GetChar(void);
int yesno(char *title,char *mess);
void ProcessDosError(void);

int BUTTON::PressButton(void)
{
mouse_hide();

int x1,x2,y1,y2;



x1=x;
x2=x+length;
y1=y;
y2=y+heigth;


// setlinestyle(SOLID_LINE,0,1);
VideoSetFillStyle(0,DARKGRAY);
VideoBar(x1,y1,x2,y2);



VideoSetColor(BLACK);
VideoRectangle(x1,y1,x2,y2);

VideoLine(x1-1, y1+1, x1-1,   y2-1);
VideoLine(x2+1, y1+1, x2+1,   y2-1);

VideoSetColor(BLACK);
UnderlineString( x1+((x2-x1-strlen(label)*8)/2)+2, y1+((y2-y1-4)/2+1), label);

mouse_show();

delay(300);
ShowButton();

VideoSetColor(WHITE);
// setlinestyle(SOLID_LINE,0,1);
mouse_show();

return PRESSED;
}



BUTTON::BUTTON(WORD _x,WORD _y,WORD _length, WORD _heigth, char *_label)
{

x=_x;
y=_y;
length=_length;
heigth=_heigth;
label=_label;
hotkey=0;
status=0;

}

BUTTON::BUTTON(WORD _x,WORD _y,WORD _length, WORD _heigth, char *_label, int key)
{
hotkey=key;
x=_x;
y=_y;
length=_length;
heigth=_heigth;
label=_label;
status=0;

}


void BUTTON::ShowButton(void)
{
int bc=VideoGetColor();
int x1,x2,y1,y2;
char label2[100];

label2[0]=0;

mouse_hide();

x1=x;
x2=x+length;
y1=y;
y2=y+heigth;


if(status==0) VideoSetFillStyle(0,DARKGRAY);
else          VideoSetFillStyle(0,BLACK);
VideoBar(x1,y1,x2,y2);

VideoSetColor(BLACK);
VideoRectangle(x1,y1,x2,y2);

VideoLine(x1-1, y1+1, x1-1,   y2-1);
VideoLine(x2+1, y1+1, x2+1,   y2-1);

VideoLine(x1, y2-1, x2,    y2-1);
VideoLine(x2-1, y1+2, x2-1,  y2-1);

VideoSetColor(WHITE);
VideoLine(x1+1, y1+1, x1+1,   y2-2);
VideoLine(x1+1, y1+1, x2-1, y1+1);

int i=0;
int counter=0;
int ampersand=0xffff;

VideoSetColor(7);
VideoRectangle(x1+1,y1+1,x2-1,y2-1);

if(status==0) VideoSetColor(BLACK);
else          VideoSetColor(LIGHTGRAY);
UnderlineString( x1+((x2-x1-(strlen(label)-1)*8)/2), y1+((y2-y1-4)/2), label);

VideoSetColor(bc);

mouse_show();

}


int BUTTON::ProcessEvent(EVENT *event)
{

if(status!=0) return NOT_PRESSED;

 if( event->mouse.buttons & LEFT_BUTTON) {

if((event->mouse.x>=x) && (event->mouse.x<=x+length) && (event->mouse.y>=y) && (event->mouse.y<=y+heigth))
{

 clearevent(event);
 return (PressButton());

}


					 }


if((event->keyboard)==hotkey) {

 clearevent(event);
 return (PressButton());

			      }
else   return NOT_PRESSED;


}




int WINDOW::ShowWindow(void)
{

mouse_hide();

h=0xff;

if(h==0xff)
{

//if((save=malloc( qmemimag(length+3,width+3)) ) == 0)

int MemNeed=EvaluateBlockSize(x,y,x+length+3+16,y+width+3);

if((save=malloc(MemNeed))==0)
{

//     printf("Out of memory to open window! Needed %u bytes;\n\r",MemNeed);
//     ProcessDosError();
       return -1;
}

flag=1;

}

ShowMem();
//qrdimag(x-1,y-1,length+3,width+3,save);
GetBlock(x-1,y-1,(length+3)/8+2,width+3,(char *) save);

int bc=VideoGetColor();

VideoSetFillStyle(0,background);
VideoBar(x,y,x+length,y+width);

if((style==0L)) { DrawFrame(); }

else {

DrawHeader();
DrawFrame();

      }
mouse_show();


VideoSetColor(bc);

return 0;

}


void WINDOW::DrawFrame(void)
{
int bc=VideoGetColor();

if((style & DLG_FRAME)) {

VideoSetColor(BLUE);

VideoRectangle(x-1,y-1, x+length+1, y+width+1);
VideoRectangle(x,y, x+length, y+width);
VideoRectangle(x+1,y+1, x+length-1, y+width-1);

VideoSetColor(bc);
return;
			}

VideoSetColor(BLACK);

VideoRectangle(x,y, x+length, y+width);

// setlinestyle(SOLID_LINE,0,1);
VideoSetColor(bc);

}


void WINDOW::DrawHeader(void)
{

if((style & ERR_FRAME)) {

VideoSetFillStyle(0,RED);
VideoBar(x+3,y+3,x+length-3,y+12);

			 }
else {

VideoSetFillStyle(0,BLUE);
VideoBar(x+3,y+3,x+length-3,y+12);

     }

VideoSetColor(WHITE);
VideoOutTextXY(x+length/2-strlen(header)*8/2, y+4, header);

}



void WINDOW::DeleteWindow(void)
{

 mouse_hide();

// qwrimag(x-1,y-1,save);
PutBlock(x-1,y-1,(length+3)/8+2,width+3,(char *) save);
 free(save);
 save=0;

 ShowMem();

 mouse_show();

}


void MessageBox(char *m,int st)
{

WinMessageBox("Message",m,st);

}



WINDOW::WINDOW(WORD xx,WORD yy, WORD len1, WORD width1,  char *h)
{
 header=h;

 x=xx;
 y=yy;

 length=len1;
 width=width1;
 style=1;
 background=WHITE;

 if(x==-1) { x=VideoGetMaxX()/2-length/2;  }
 if(y==-1) { y=VideoGetMaxY()/2-width/2;  }

}


VSCROLL::VSCROLL(WORD xx, WORD yy, WORD hei)
{
x=xx;
y=yy;
heigth=hei;
howmany=0;
absposition=0;
}


VSCROLL::VSCROLL(WORD xx, WORD yy, WORD hei, WORD _howmany)
{

x=xx;
y=yy;
heigth=hei;
howmany=_howmany;
absposition=0;

}

void VSCROLL::DeletePointer(void)
{
int yy;
if(howmany==0) yy=y+13;
else           yy=y+13+(absposition*(heigth-12*3-2) )/howmany;

VideoSetFillStyle(0,11);
mouse_hide();
VideoBar(x+1, yy, x+15, yy+12);
mouse_show();

}

void VSCROLL::DrawPointer(void)
{
int yy;
if(howmany==0) yy=y+13;
else           yy=y+13+(absposition*(heigth-12*3-2) )/howmany;

VideoSetFillStyle(0,LIGHTGRAY);
mouse_hide();
VideoBar(x+1, yy, x+15, yy+12);
mouse_show();

}


void VSCROLL::Show(void)
{
int bc=VideoGetColor();

VideoSetFillStyle(0,11);
VideoBar(x,y,x+16,y+heigth);
VideoSetColor(BLACK);
VideoRectangle(x,y,x+16,y+heigth);

VideoRectangle(x,y,x+16,y+12);
VideoRectangle(x,y,x+16,y+heigth-12);

VideoSetColor(DARKGRAY);
VideoOutTextXY(x+5, y+3, "\30");
VideoOutTextXY(x+5, y+heigth-10+1, "\31");

DrawPointer();

VideoSetColor(bc);

}


int BUTTON::ProcessEvent(struct MouseEvent event)
{

 if( event.buttons & LEFT_BUTTON) {

if((event.x>=x) && (event.x<=x+length) && (event.y>=y) && (event.y<=y+heigth))
{

 return (PressButton());

}

 else return NOT_PRESSED;

				   }
}



int VSCROLL::ProcessEvent(EVENT event)
{
// Returns: 0--if nothing happened, 1--scrol up, 2--scroll down
int len=x+16;


 if( event.mouse.buttons & LEFT_BUTTON) {

if((event.mouse.x>=x) && (event.mouse.x<=len) && (event.mouse.y>=y) && (event.mouse.y<=y+heigth))
{

if((event.mouse.x>=x) && (event.mouse.x<=len) && (event.mouse.y>=y) && (event.mouse.y<=y+12))
{

if(absposition>0)
{
DeletePointer();
absposition--;
DrawPointer();
}

else              return 0;



return SCROLL_UP;

}

if((event.mouse.x>=x) && (event.mouse.x<=len) && (event.mouse.y>=y+heigth-12) && (event.mouse.y<=y+heigth))
{

if(absposition<howmany)
{
DeletePointer();
absposition++;
DrawPointer();
}

else          return 0;

return SCROLL_DOWN;
}

}

}

if(event.keyboard==UP)
{

if(absposition>0)
{
DeletePointer();
absposition--;
DrawPointer();
}

else              return 0;

return SCROLL_UP;

}

if(event.keyboard==DOWN) {

if(absposition<howmany)
{
DeletePointer();
absposition++;
DrawPointer();
}

else          return 0;

return SCROLL_DOWN;
			  }

return 0;

}


WINDOW::WINDOW(WORD xx,WORD yy, WORD len1, WORD width1,  char *h,DWORD _style)
{

 header=h;
 x=xx;
 y=yy;
 length=len1;
 width=width1;
 style=_style;
 background=WHITE;

 if(x==-1) { x=VideoGetMaxX()/2-length/2;  }
 if(y==-1) { y=VideoGetMaxY()/2-width/2;  }
}

MENULIST::MENULIST(WORD xx, WORD yy, WORD _len, WORD num, char **massiv)
:mywin(xx,yy,_len*8+2,num*12+2 ,"",0L)
{

x=xx;
y=yy;
number=num;
list=massiv;
style=0;
current=0;
len=_len;

}


int MENULIST::Show(void)
{
int bc=VideoGetColor();

mywin.background=LIGHTCYAN;
int k=mywin.ShowWindow();


VideoSetColor(BLACK);

for(int i=0; i<number; i++)
	 Unselect(i);

Select(current);

VideoSetColor(bc);
return k;
}


void MENULIST::Delete(void)
{

 mywin.DeleteWindow();

}


void MENULIST::Select(WORD n)
{
mouse_hide();

selitem=n;

int bc=VideoGetColor();

if(strlen(list[n])>0) {

VideoSetFillStyle(0,BLACK);
VideoBar(x, y+1+12*n, x+len*8+1, y+1+12*n+12);

VideoSetColor(WHITE);
UnderlineString(x+4, y+1+2+12*n, list[n]);

		       }

VideoSetColor(bc);
mouse_show();
}



void MENULIST::Unselect(WORD n)
{
mouse_hide();				// While ...
int bc=VideoGetColor();

selitem=-1;

if(strlen(list[n])>0) {

VideoSetFillStyle(0,LIGHTCYAN);
VideoBar(x+1, y+1+12*n, x+len*8+1, y+1+12*n+12);

VideoSetColor(BLACK);
UnderlineString(x+4, y+1+2+12*n, list[n]);

		      }
else  {

VideoSetFillStyle(0,LIGHTCYAN);
VideoBar(x+1, y+1+12*n, x+len*8+1, y+1+12*n+12);

VideoSetColor(BLACK);
VideoLine(x, y+1+2+12*n+4, x+len*8+1, y+1+2+12*n+4);

      }

VideoSetColor(bc);
mouse_show();
}


int MENULIST::ProcessEvent(EVENT event)
{
int i;
switch(event.keyboard) {


case UP:  if(current>0)
		{

Unselect(current);
		if((Check(current-1)==0)) current--;
		else              current-=2;

Select(current);

		 }

		return ML_UP;

case DOWN:  if(current<number-1)
		{

Unselect(current);
		if((Check(current+1)==0)) current++;
		else              current+=2;

Select(current);

		}

		return ML_DOWN;

case ENTER: Delete(); return ML_SELECTED;

Cancel:

case ESC:   Delete(); return ML_CANCEL;

default: break;

};


if(event.mouse.buttons & LEFT_BUTTON) {

if((event.mouse.x>=x) && (event.mouse.x<=x+len*8) && (event.mouse.y>=y) && (event.mouse.y<=y+number*12+2))
{
i=(event.mouse.y-y)/12;


if( Check(i)==0) {

Unselect(current);
current=i;
Select(current);
Delete();
return ML_SELECTED;
		}

}
else  goto Cancel;
}

if(event.mouse.buttons==0) {

if((event.mouse.x>=x) && (event.mouse.x<=x+len*8) && (event.mouse.y>=y) && (event.mouse.y<=y+number*12+2))
{
i=(event.mouse.y-y)/12;

if(i==number) goto ex;
if(selitem!=i) {
if( Check(i)==0) {
int r;

if(i<current) r=ML_UP;
else          r=ML_DOWN;

Unselect(current);
current=i;
Select(current);

return r;
		 }
		}
}

}


ex:

return ML_NOTHING;
}


int MENULIST::Check(WORD n)
{

if((strlen(list[n]))>0) return 0;
else                    return 1;

}


void UnderlineString(int x, int y, char *str)
{
int len=strlen(str);
int num=0xffff;
char text[2];
int pos=0;

text[1]=0;


for(int i=0; i<len; i++) {

if(str[i]=='&') { num=i+1; }
else            { pos++; text[0]=str[i]; VideoOutTextXY(x+8*pos-8,y,text);   }

			 }

if(num!=0xffff) {

      VideoLine(x+8*num-8,y+8,x+8*num-2,y+8);

		}

}

void  WINDOW::RPrint(int xx,int yy,char *s,int col,...)
{
int bc=VideoGetColor();
mouse_hide();

VideoSetColor(col);

va_list  argptr;			/* Argument list pointer	*/
char str[140];			        /* Buffer to build sting into	*/
int cnt;				/* Result of SPRINTF for return */
str[0]=0;

  va_start( argptr, s );		/* Initialize va_ functions	*/

  cnt = vsprintf( str, s, argptr );	/* prints string to buffer	*/
if(xx==-1)
{

VideoOutTextXY(x+1+length/2-strlen(str)*4, y+yy+13,str);

}

else
{

VideoOutTextXY(x+xx+1, y+yy+13,str);

}

  va_end( argptr );			/* Close va_ functions		*/

mouse_show();
VideoSetColor(bc);
}


void WINDOW::Print(int xx,int yy,char *s,...)
{
mouse_hide();
va_list  argptr;			/* Argument list pointer	*/
char str[140];			        /* Buffer to build sting into	*/
int cnt;			 	/* Result of SPRINTF for return */
str[0]=0;
int bc=VideoGetColor();
VideoSetColor(tcolor);

  va_start( argptr, s );		/* Initialize va_ functions	*/
  cnt = vsprintf( str, s, argptr );	/* prints string to buffer	*/

if(xx==-1)
{

VideoOutTextXY(x+1+length/2-strlen(str)*4, y+yy+13,str);

}

else
{

VideoOutTextXY(x+xx+1, y+yy+13,str);

}

mouse_show();
  va_end( argptr );

VideoSetColor(bc);
}

void WINDOW::Clear(int xx,int yy,int len,int hei)
{
mouse_hide();
int bc=VideoGetColor();

VideoSetFillStyle(0,background);
VideoBar(xx+x,y+yy+13,xx+x+len,y+yy+13+hei);

VideoSetColor(bc);
mouse_show();
}


void WINDOW::UString(int xx,int yy,char *s)
{
int bc=VideoGetColor();
mouse_hide();

  VideoSetColor(tcolor);
  UnderlineString(x+xx+1, y+yy+13,s);

VideoSetColor(bc);
mouse_show();
}

void WINDOW::Print(int xx,int yy,char *s,int col,...) // Print with color
{
mouse_hide();

va_list  argptr;			/* Argument list pointer	*/
char str[140];			        /* Buffer to build sting into	*/
int cnt;				/* Result of SPRINTF for return */
str[0]=0;
int bc=VideoGetColor();
VideoSetColor(col);
  va_start( argptr, s );		/* Initialize va_ functions	*/

  cnt = vsprintf( str, s, argptr );	/* prints string to buffer	*/


if(xx==-1)
{
VideoOutTextXY(x+1+length/2-strlen(str)*4, y+yy+13,str);
}

else
{

VideoOutTextXY(x+xx+1, y+yy+13,str);

}


  va_end( argptr );			/* Close va_ functions		*/

mouse_show();
VideoSetColor(bc);
}

void ShowWindow(int x,int y,int length,int width,char *header)
{
mouse_hide();

VideoSetFillStyle(0,WHITE);
VideoBar(x,y,x+length,y+width);

VideoSetFillStyle(0,LIGHTBLUE);
VideoBar(x,y,x+length,y+12);

VideoOutTextXY(x+length/2-strlen(header)*8/2, y+4, header);

// setlinestyle(SOLID_LINE,0,2);
int bc=VideoGetColor();
VideoSetColor(BLACK);

VideoRectangle(x,y, x+length, y+width);

// setlinestyle(SOLID_LINE,0,1);
VideoSetColor(bc);

mouse_show();

}

MENUBAR::MENUBAR(int _x,int _y,int _num,MENU *mnu)
{
x=_x;
y=_y;
num=_num;
barmenuitems=mnu;

}

void MENUBAR::Show(void)
{

for(int i=0; i<num; i++) Unselect(i);

}

void MENUBAR::Unselect(int n)
{
int sum=0;
int len1=0;
int bc=VideoGetColor();

mouse_hide();
for(int i=0; i<n; i++) sum+=strlen(barmenuitems[i].name)*8;

VideoSetFillStyle(0,LIGHTCYAN);
VideoBar(x+sum, y, x+sum+strlen(barmenuitems[n].name)*8, y+12);
VideoSetColor(BLACK);
UnderlineString(x+sum, y+3, barmenuitems[n].name);

VideoSetColor(bc);
mouse_show();
}

void MENUBAR::Select(int n)
{
int sum=0;
int len1=0;
int bc=VideoGetColor();

for(int i=0; i<n; i++) sum+=strlen(barmenuitems[i].name)*8;

mouse_hide();
VideoSetFillStyle(0,BLACK);
VideoBar(x+sum,y,x+sum+strlen(barmenuitems[n].name)*8,y+12);
VideoSetColor(WHITE);
UnderlineString(x+sum, y+3, barmenuitems[n].name);

VideoSetFillStyle(0,WHITE);
VideoSetColor(bc);
mouse_show();
}

int MENUBAR::GetMouseChoice(EVENT *event)
{
int len=0;
int ilen=0;
int hei=12;

// if( event->mouse.buttons & LEFT_BUTTON) {

for(int i=0; i<num; i++) len+=strlen(barmenuitems[i].name)*8;

if((event->mouse.x>=x) && (event->mouse.x<=x+len) && (event->mouse.y>=y) && (event->mouse.y<=y+hei))
{
// Find out where mouse button pressed

for(int k=0; k<num; k++) {

len=0;
ilen=0;
for(int i=0; i<k; i++) { len+=strlen(barmenuitems[i].name)*8; }
		       ilen=strlen(barmenuitems[k].name)*8;

if((event->mouse.x>=x+len) && (event->mouse.x<=x+len+ilen) && (event->mouse.y>=y) && (event->mouse.y<=y+hei))
{
EVENT e;
con:

e=_GetEvent();
if(e.mouse.buttons!=0) goto con;
if((e.mouse.x>=x+len) && (e.mouse.x<=x+len+ilen) && (e.mouse.y>=y) && (e.mouse.y<=y+hei))
	return k;
else    return -1;

}
			 }

}

 //				  }

return -1;

}


int MENUBAR::ProcessEvent(EVENT *event)
{
int len,hei,k;


if((k=GetMouseChoice(event))!=-1) {

	clearevent(event);
	return (Work(k));

				  }


for(int i=0; i<num; i++) {

if(event->keyboard==barmenuitems[i].key)
 {

 clearevent(event);
 return (Work(i));

 }

			 }

return 0;
}


int  MENUBAR::Work(int nn)
{
int sum;
int n=nn;

start:

sum=0;
for(int i=0; i<n; i++) sum+=strlen(barmenuitems[i].name)*8;

Select(n);

MENULIST m(x+sum, y+13, barmenuitems[n].maxlen, barmenuitems[n].num, barmenuitems[n].menuitems);
m.Show();

EVENT event;
int k,j;
go:

event=_GetEvent();

j=GetMouseChoice(&event);
if((j!=-1) && (j!=n)) {
	    m.Delete();
	    Unselect(n);
	    n=j;
	    goto start;
		     }

switch(event.keyboard) {

case LEFT:
	    m.Delete();
	    Unselect(n);
	    if(n>0) n--;
	    else    n=num-1;

	    goto start;

case RIGHT:
	    m.Delete();
	    Unselect(n);
	    if(n<num-1) n++;
	    else        n=0;

	    goto start;

case 0:

default:
	    break;

};


k=m.ProcessEvent(event);

switch(k) {

case ML_SELECTED:
	Unselect(n);
	return (barmenuitems[n].values[m.current]);

case ML_CANCEL:
	Unselect(n);
	return 0;

default: goto go;

};

}

NUMBER::NUMBER(int *val,int xx,int yy,int mn,int mx, int d)
{
value=val;
x=xx;
y=yy;
min=mn;
max=mx;
delta=d;
}

NUMBER::NUMBER(int *val,int xx,int yy,int mn,int mx)
{
value=val;
x=xx;
y=yy;
min=mn;
max=mx;
delta=1;
}


void NUMBER::Show(void)
{
mouse_hide();
int bc=VideoGetColor();

VideoSetFillStyle(0,WHITE);
VideoBar(x,y,x+8+5*8+8*2,y+8+8+4);
VideoSetColor(BLACK);
VideoRectangle(x,y,x+8+5*8+8*2,y+8+8+4);
VideoRectangle(x+8+5*8,y,x+8+5*8+8*2,y+8+8+4);

gprintf(x+4,y+7,"%d",*value);
VideoLine(x+8+5*8,y+10,x+8+5*8+8*2,y+10);
VideoOutTextXY(x+8+5*8+4+1,y+2,"\x1e");
VideoOutTextXY(x+8+5*8+4+1,y+12,"\x1f");

VideoSetColor(bc);
mouse_show();
}


int  NUMBER::ProcessEvent(EVENT *event)
{
int xx=x+8+5*8;
int yy=y;


 if( event->mouse.buttons & LEFT_BUTTON) {

if((event->mouse.x>=xx) && (event->mouse.x<=xx+16) && (event->mouse.y>=yy) && (event->mouse.y<=yy+10))
{
event->mouse.buttons=0;
event->keyboard=0;

if(((*value)+delta)<max) {
(*value)+=delta;
Show();
delay(100);
return 0;
	       }

return -1;
}

if((event->mouse.x>=xx) && (event->mouse.x<=xx+16) && (event->mouse.y>=yy+10) && (event->mouse.y<=yy+20))
{
event->mouse.buttons=0;
event->keyboard=0;

if(((*value)-delta)>min) {
(*value)-=delta;
Show();
delay(100);
return 0;
	      }

return -1;
}


				  }

return -1;
}




FRAME::FRAME(int xx,int yy,int _sx,int _sy,char *l)
{
x=xx;
y=yy;
label=l;
sx=_sx;
sy=_sy;

}

void FRAME::Show(void)
{
int bc=VideoGetColor();
mouse_hide();

VideoSetFillStyle(0,WHITE);
VideoBar(x,y,x+sx,y+sy);

VideoSetColor(BLACK);
VideoRectangle(x,y,x+sx,y+sy);

int xx=x+8;
VideoSetColor(WHITE);

VideoLine(xx,y,xx+strlen(label)*8,y);
VideoSetColor(BLACK);
VideoOutTextXY(xx,y-3,label);

mouse_show();
VideoSetColor(bc);
}

LIST::LIST(int xx,int yy,int _sh,int _n,int ln,char **massiv)
 :scroller()
{
len=ln;
curr=0;
x=xx;
y=yy;
list_num=_n;
show_num=_sh;
list=massiv;
realshow=0;

}

void LIST::Update(void)
{
mouse_hide();
int limit;

if(show_num>list_num) limit=list_num;

for(int i=realshow; i<realshow+show_num; i++)
	  Unselect(i);

Select(curr);
mouse_show();
}

void LIST::Show(void)
{
int bc=VideoGetColor();
mouse_hide();

VideoSetFillStyle(0,WHITE);
VideoBar(x,y,x+2+len*8,y+show_num*10+2);
VideoSetColor(BLACK);
VideoRectangle(x, y ,x+2+len*8, y+show_num*10+2);

scroller.x=x+1+1+len*8-16;
scroller.y=y;
scroller.howmany=list_num;
scroller.absposition=0;
scroller.heigth=show_num*10+2;

scroller.Show();
int limit;

if(show_num>list_num) limit=list_num;
else                  limit=show_num;

for(int i=curr; i<limit; i++)
	  Unselect(i);

Select(curr);

mouse_show();
VideoSetColor(bc);

}

void LIST::Unselect(int n)
{

if(list_num==0)
{
//MessageBox("|~ListBox:|~Empty list box to show!|",1);
return;
}

int bc=VideoGetColor();
mouse_hide();
int place;


place=n-realshow;

VideoSetFillStyle(0,WHITE);
VideoBar(x+1, y+1+10*place, x+2+len*8-17, y+1+10*place+10);
VideoSetColor(BLACK);
VideoOutTextXY(x+4, y+1+10*place+1, list[n]);

mouse_show();
VideoSetColor(bc);
}

void LIST::Select(int n)
{

if(list_num==0)
{
//MessageBox("|~ListBox:|~Empty list box to show!|",1);
return;
}

int bc=VideoGetColor();
mouse_hide();

int place=n-realshow;

VideoSetFillStyle(0,BLACK);
VideoBar(x+1, y+1+10*place, x+2+len*8-17, y+1+10*place+10);
VideoSetColor(WHITE);
VideoOutTextXY(x+4, y+1+10*place+1, list[n]);

mouse_show();
VideoSetColor(bc);
}

int LIST::ProcessEvent(EVENT *event)
{

switch(scroller.ProcessEvent(*event)) {

 case SCROLL_UP:    Up();      clearevent(event); break;

 case SCROLL_DOWN:  Down();    clearevent(event); break;

 case 0:
 default:
	 return 0;
};

	 return 1;
}

void clearevent(EVENT *event)
{
event->keyboard=0;
event->mouse.buttons=0;
}


void LIST::Up(void)
{

if((((curr-1)<realshow) && (curr!=0)))
{
realshow--;
curr=realshow;

 for(int i=realshow; i<realshow+show_num; i++)
  { Unselect(i); }

 Select(curr);
 return;
}

if(curr>0) { Unselect(curr); curr--; Select(curr); }
else       { return; }

}


void LIST::Down(void)
{

if( (((curr)==(realshow+show_num-1)) && (curr<list_num-1)))
{
realshow++;
curr=realshow+show_num-1;

 for(int i=realshow; i<realshow+show_num; i++)
  { Unselect(i); }

 Select(curr);
 return;
}

if(curr<list_num-1) { Unselect(curr); curr++; Select(curr); }
else                { return; }


}

InputLine::InputLine()
{
hotkey=0;
}

InputLine::InputLine(int xx,int yy,char *s,int l)
{
x=xx; y=yy; string=s; maxlen=l; hotkey=0;
}

InputLine::InputLine(int xx,int yy,char *s,int l,int key)
{
x=xx; y=yy; string=s; maxlen=l; hotkey=key;
}


void InputLine::Show(void)
{
int bc=VideoGetColor();
mouse_hide();

VideoSetFillStyle(0,WHITE);
VideoBar(x,y,x+2+maxlen*8+8+8,y+16);
VideoSetColor(0);
VideoRectangle(x,y,x+2+maxlen*8+8+8,y+16);

VideoOutTextXY(x+8, y+5, string);

mouse_show();
VideoSetColor(bc);
}

int InputLine::ProcessEvent(EVENT *event)
{

if(event->keyboard==hotkey)
{
SELECT:

GetStringXY(x+4,y+5,string,maxlen);
clearevent(event);
return 0;
}

 if( event->mouse.buttons & LEFT_BUTTON) {
if((event->mouse.x>=x) && (event->mouse.x<=x+maxlen*8+18) && (event->mouse.y>=y) && (event->mouse.y<=y+16))
{ goto SELECT; }

					 }
return 1;
}


   int GetStringXY(int x,int y,char *s,int len)
{
int curr,status,l;
char c;
int h,w;
EVENT event;

l=strlen(s)+1;
VideoSetFillStyle(0,WHITE);
VideoSetColor(0);

status=0;
curr=l-1;

VideoOutTextXY(x+4, y, s);

go:

if(kbhit()==0) {
		     ShowCursor(x+4+strlen(s)*8+2,y);
				     // Smart delay:
		     for(int i=0; i<25; i++) {
		       delay(10);

		       if(kbhit()!=0) {

event=_GetMouseEvent();

 if( event.mouse.buttons & LEFT_BUTTON) {
if((event.mouse.x>=x) && (event.mouse.x<=x+len*8+18) && (event.mouse.y>=y) && (event.mouse.y<=y+16))
{

;

}

else { HideCursor(x+4+strlen(s)*8+2,y); goto ex; }

				       }


					HideCursor(x+4+strlen(s)*8+2,y);
					goto work;
				      }
					     }
		     HideCursor(x+4+strlen(s)*8+2,y);

		     // Smart delay:
		     for(i=0; i<25; i++) {
		       delay(10);

event=_GetMouseEvent();

 if( event.mouse.buttons & LEFT_BUTTON) {
if((event.mouse.x>=x) && (event.mouse.x<=x+len*8+18) && (event.mouse.y>=y) && (event.mouse.y<=y+16))
{

;

}

else { HideCursor(x+4+strlen(s)*8+2,y); goto ex; }

					}

		       if(kbhit()!=0) goto work;
					     }
		     goto go;
		}

work:

switch((c=getch())) {

 case 13:  return 1; // ENTER

ex:
 case 27:  return 2;  // ESC

 case 8:

if(l==1) {  sound(50); delay(100); nosound(); goto go; }
else     l--;

h=8;
w=strlen(s)*8;

   curr--;
   s[curr]=0;

 VideoSetFillStyle(0,WHITE);
 VideoBar(x+4,y,x+8+strlen(s)*8+8,y+8);
 VideoOutTextXY(x+4,y, s);

goto go;

default:

    if(l>len) {     sound(50); delay(100); nosound(); goto go; }

    s[curr]=c;
    curr++;

    s[curr]=0;

  VideoOutTextXY(x+4,y, s);

    l++;

};

goto go;

}


void HideCursor(int x,int y)
{
int bc=VideoGetColor();
mouse_hide();

VideoSetColor(15);
VideoOutTextXY(x,y,"");

mouse_show();
VideoSetColor(bc);
}


void ShowCursor(int x,int y)
{
int bc=VideoGetColor();
mouse_hide();

VideoSetColor(0);
VideoOutTextXY(x,y,"");

mouse_show();
VideoSetColor(bc);

}

STATUSLINE::STATUSLINE(int xx, int yy, int _len, int _curr, int _max)
{

x=xx; y=yy;
len=_len;
curr=_curr; max=_max;

}

void STATUSLINE::Show(void)
{
int bc=VideoGetColor();
mouse_hide();
int flen;


flen=(curr*len)/max;
VideoSetColor(BLACK);

if(flen<0)
{
printf("Flen=%d,Curr=%d; ",flen,curr);
getch();
}

VideoSetFillStyle(0, LIGHTBLUE);
VideoBar(x+1, y, x+1+flen, y+16);

VideoSetFillStyle(0, RED);
VideoBar(x+1+flen, y, x+len, y+16);

VideoRectangle(x, y, x+len+1, y+17);

VideoSetColor(WHITE);
gprintf(x+len/2-3*8/2, y+6, "%d%%", (curr*100)/max );

mouse_show();
VideoSetColor(bc);
}

void STATUSLINE::Add(int n)
{

if(((curr+n)<=max) && (curr+n)>0)
   {

if( ((curr*100)/max)!=((curr+n)*100)/max)
{
   curr+=n;
   Show();
}
else { curr+=n; }

   }

else
   {
     curr=max;
     Show();
   }

}
/*
class ITEM {

public:

int x,y;
int state;  // 1--on, 0--off;
int hotkey;

ITEM(int,int,int,int);
int  ProcessEvent(EVENT *);
void Show(void);

};
*/


void ITEM::Show(void)
{
mouse_hide();
int bc=VideoGetColor();

VideoSetFillStyle(0,WHITE);

VideoBar(x,y,x+16,y+12);
VideoSetColor(0);
VideoRectangle(x,y,x+16,y+12);

if(state!=0)
{

VideoLine(x,y,x+16,y+12);
VideoLine(x,y+12,x+16,y);

}

VideoSetColor(bc);
mouse_show();
}

int ITEM::ProcessEvent(EVENT *event)
{

if(hotkey==event->keyboard)
{

if(state==0) state=1;
else         state=0;

Show();
clearevent(event);

}

return 1;
}

/*

class ComboBox {

public:

int x,y;
char **list;
int current;


ComboBox(int,int,int,char **);
void Show(void);
int ProcessEvent(EVENT *);

};

*/

void ComboBox::Show(void)
{
mouse_hide();
int bc=VideoGetColor();

VideoSetFillStyle(0,WHITE);

VideoBar(x,y,x+8*length+1+1+1+16,y+16);
VideoSetColor(0);
VideoRectangle(x,y,x+8*length+1+1+1+16,y+16);

VideoOutTextXY(x+6,y+5,list[current]);

VideoRectangle(x+8*length+1+1+1,y,x+8*length+1+1+1+16,y+16);
VideoOutTextXY(x+8*length+1+1+1+5,y+6,"\31");

VideoSetColor(bc);
mouse_show();
}

int ComboBox::ProcessEvent(EVENT *event)
{
int wx=x+8*length+1+1+1;

if(event->keyboard==kbF10) { goto Work; }

 if( event->mouse.buttons & LEFT_BUTTON) {

if((event->mouse.x>=wx) && (event->mouse.x<=wx+16) && (event->mouse.y>=y) && (event->mouse.y<=y+16))
{

Work:

clearevent(event);
MENULIST m(x, y+16, length+2, number, list);
m.Show();

EVENT e;

go:

e=_GetEvent();

int k=m.ProcessEvent(e);

switch(k) {

case ML_SELECTED:
	m.Delete();
	current=m.current;
	Show();
	return 0;

case ML_CANCEL:
	m.Delete();
	return 1;

default: goto go;

};


}

					 }
return 1;
}


void ProcessDosError(void)
{

switch(errno)
{

case EINVMEM: puts("DOS: Invalid memory block address"); break;
case ECONTR : puts("DOS: Memory blocks destroyed"); break;
case EFAULT : printf("DOS: Unknown error: %d",errno); break;
case ENOMEM : puts("DOS: Not enough memory"); break;

default: printf("Unknown DOS error: %d",errno); break;

};

}