#include "stdio.h"
#include "dos.h"
#include "io.h"
#include "stdlib.h"
#include "conio.h"
#include "fcntl.h"

char far *buf;

int  LoadPalette(char *PalFile)
{
char Palette[768];
int sg,so;
int handle;

if((handle=_open(PalFile, O_RDWR))==-1)  { puts("Unable to open .PAL file!"); return -1; }

if((_read(handle,Palette,768))==-1)  { puts("Unable to read .PAL file!");  return -1; }

close(handle);

sg=FP_SEG(Palette);
so=FP_OFF(Palette);

asm {

mov ax,1012h
mov dx,sg
mov es,dx
mov dx,so

xor bx,bx
mov cx,256
int 10h

};

return 0;
}

void putpixel(int x,int y,char col)
{

_AH=0x0c;
_BH=0;
_CX=x;
_DX=y;
_AL=col;
asm int 10h;

}

void main(int argc,char **argv)
{
int h,x,y;
char mode;
int bytes;
char color;

if(argc<2) { puts("Extra argument missing"); return; }
if(argc==3) { printf("Loading VGA pallete: "); LoadPalette(argv[2]); }

if((h=_open(argv[1],O_RDWR))==-1)
{
printf("Unable to open '%s'",argv[1]);
return;
}


buf=(char *) malloc(64000);

if(buf==0)
{
puts("Out of memory!");
return;
}

bytes=_read(h,buf,64000);

if(bytes==-1)
{
puts("Read error!");
return;
}

if(bytes==32000)
{
puts("Unexpected EOF!");
return;
}

asm {
push ax
xor ax,ax;
mov al,0Dh
int 10h
pop ax
};


for(y=0; y<200; y++)
for(x=0; x<320; x++) putpixel(x,y,buf[x+y*320]);

getch();

asm {
mov ax,0003h;
int 10h;
};

close(h);
}