/*

  Library File V1.0
  (C) M.S.G.

*/

#include "stdlib.h"
#include "stdio.h"
#include "conio.h"
#include "time.h"
#include "string.h"
#include "fcntl.h"
#include "dos.h"
#include "stdarg.h"
#include "ctype.h"
#include "process.h"
#include "dir.h"
#include "io.h"
#include "pcxlib.h"
#include "alloc.h"
#include "gamekit.h"
#include "objects.h"
#include "tkeys.h"
#include "library.h"

#include "video.h"

int MessageBoxf(int st,char *fmt, ... );

int libnumber=100;
char *libname="sprites.sl  ";
char *addname="_stALker";

void optimize_library(void);
void real_optimize(char *);
LIB_ITEM libitems[100]={ 0 };

void creat_library(void)
{
int handle;

WINDOW w(-1,-1,260,140,"Creat library",DLG_FRAME);
w.ShowWindow();


w.SetTextColor(BLACK);
NUMBER item(&libnumber,w.x+25,w.y+30+50,1,200,100);

InputLine il(w.x+130, w.y+30, libname, 12, kbAltL);

BUTTON ok(w.x+20,w.y+115, 80, 20, "&OK",kbEnter);
BUTTON cancel(w.x+160,w.y+115, 80, 20, "&Cancel",kbEsc);

w.Print(130, 25+50, "Number of items");
w.UString(10, 23, "&Library name:");

item.Show();

il.Show();
ok.ShowButton();
cancel.ShowButton();

EVENT event;
go:

event=_GetEvent();
il.ProcessEvent(&event);
item.ProcessEvent(&event);


if(ok.ProcessEvent(&event)==PRESSED)
{

if((handle=_creat((char far*) libname,FA_ARCH))==-1)
{
  MessageBoxf(1,"Unable to creat: '%s'",libname);
  goto go;
}


WINDOW c(-1,-1,200,100,"Creating library",DLG_FRAME);

c.ShowWindow();


STATUSLINE sl(c.x+20, c.y+50, 160, 1, libnumber );

sl.Show();

 LIB_HEADER lh;

lh.NK[0]='N';
lh.NK[1]='K';
lh.maxitems=libnumber;
lh.defitems=0;
lh.version=LIB_VERSION;

 if((write(handle, &lh, 8))==-1)
 {

 MessageBoxf(1,"Unable to write header");

 }

 LIB_ITEM li;

for(int i=0; i<libnumber; i++)
{

libitems[i].len=0;
libitems[i].offset=0;
libitems[i].name[0]=0;
strcat(libitems[i].name,"_Vacant_");

sl.Add(1);

}

if(write(handle, libitems, sizeof(li)*libnumber)==-1)
{

MessageBoxf(1,"Unable to write data in '%s'",libname);

}


close(handle);
c.DeleteWindow();
w.DeleteWindow();
mouse_show();
return;
}


if(cancel.ProcessEvent(&event)==PRESSED)
{

w.DeleteWindow();
return;

}

if(event.keyboard!=ESC) goto go;

w.DeleteWindow();

}


void add_library(void)
{
int handle, sprhandle;
struct icon_header sprite;
char name[30];
char sname[30];
name[0]=0; sname[0]=0;
void *buffer;
void *mask;
int i=0;

WINDOW w(-1,-1,260,160,"Add to library",DLG_FRAME);
w.ShowWindow();

InputLine il(w.x+150, w.y+30, addname, 8, kbAltA);

BUTTON ok(w.x+20,w.y+135, 50, 20, "&OK",kbEnter);
BUTTON browse(w.x+85,w.y+135, 70, 20, "&Browse",kbAltB);
BUTTON cancel(w.x+170,w.y+135, 70, 20, "&Cancel",kbEsc);
 LIB_HEADER lh;
 LIB_ITEM   li;

ok.ShowButton();
cancel.ShowButton();
browse.ShowButton();

il.Show();
w.SetTextColor(BLACK);
w.UString(10, 23, "&Add with name:");

LIBBROWSE:
  if((getfile("*.SL", "Pick a library",name))==0) { goto ex; }

BROWSE:
  if((getfile("*.SPR","Pick a sprite",sname))==0) { goto ex; }


if((handle=open(name,O_RDWR))==-1)
{
MessageBoxf(1,"Unable to open '%s'",name);
goto LIBBROWSE;
}


if((sprhandle=open(sname,O_RDWR))==-1)
{
MessageBoxf(1,"Unable to open '%s'",sname);
goto BROWSE;
}

 if((read(handle, &lh, 8))==-1)
 {

 MessageBoxf(1,"Unable to read '%s' header",name);

 }


if((lh.NK[0]!='N') || (lh.NK[1]!='K'))
{

MessageBox("Incorrect library header",1);
goto go;

}


if(lh.version!=LIB_VERSION)
{

MessageBox("Incorrect library version",1);
goto go;

}

if(lh.maxitems<=lh.defitems)
{
Not_room:

MessageBoxf(1,"Not free spot in '%s'",name);
goto go;

}

// Loading sprite...

 if((read(sprhandle, &sprite, sizeof(sprite)))==-1)
  {
  MessageBoxf(1,"Unable to read '%s' header",sname);
  close(handle);
  close(sprhandle);
  goto go;
  }


 if((sprite.nk[0]!='N') || (sprite.nk[1]!='K'))
  {
  MessageBoxf(1,"Incorrect '%s' header",sname);
  close(handle);
  close(sprhandle);
  goto go;
  }

 read(handle, libitems, sizeof(li)*lh.maxitems);

show_info:

  VideoSetFillStyle(0,WHITE);
  VideoBar(w.x+130,w.y+43+13,w.x+230,w.y+43+13+70);

w.SetTextColor(BLACK);
w.UString(10, 43, "Library:");
w.UString(140, 43, name);

w.UString(10, 55, "Sprite:");
w.UString(140, 55, sname);

w.SetTextColor(BLUE);
w.Print(-1,70,"---- Information -----");

w.Print(20,80,"Maximum items in .SL: %d",LIGHTBLUE, lh.maxitems);
w.Print(20,90,"Defined items in .SL: %d",LIGHTBLUE, lh.defitems);

w.Print(20,100,"Sprite's base size:  %d",LIGHTBLUE, sprite.size);

 EVENT event;
go:

event=_GetEvent();
il.ProcessEvent(&event);

if(ok.ProcessEvent(&event)==PRESSED)
{

// *******************  Adding:

buffer=malloc(sprite.size);
mask=malloc(sprite.size);

if(mask==0)
{
MessageBoxf(1,"Need mem for 'mask': %d", sprite.size);
goto go;
}

if(buffer==0)
{
MessageBoxf(1,"Need mem for 'buffer': %d", sprite.size);
goto go;
}


for(i=0; i<lh.maxitems; i++)
{

if((libitems[i].len)==0)
{
libitems[i].name[0]=0;

int k=0;
while(addname[k]!=0) { libitems[i].name[k]=addname[k]; k++; }

libitems[i].name[k]=0;
libitems[i].len=sprite.size;
libitems[i].offset=lseek(handle,0,SEEK_END);

goto go2;

}

}
goto Not_room;

go2:



 if((read(sprhandle, buffer, sprite.size))==-1)
{
MessageBoxf(1,"Unable to read sprite data");
}


 if((read(sprhandle, mask, sprite.size))==-1)
{
MessageBoxf(1,"Unable to read sprite mask!");
}


lh.defitems++;

lseek(handle,0L,SEEK_SET);

if(write(handle, &lh, sizeof(lh))==-1) goto err;


if(write(handle, libitems, sizeof(li)*lh.maxitems)==-1)
{
err:

MessageBoxf(1,"Unable to write '%s' relocation table!",name);

}


lseek(handle,0,SEEK_END);

 if((write(handle, buffer, sprite.size))==-1)
{
MessageBoxf(1,"Unable to write '%s' data",sname);
}


 if((read(handle, mask, sprite.size))==-1)
{
MessageBoxf(1,"Unable to write '%s' mask",sname);
}


aex:

free(buffer);
free(mask);
goto show_info;
}

if(browse.ProcessEvent(&event)==PRESSED) goto BROWSE;
if(cancel.ProcessEvent(&event)==PRESSED) goto ex;
else 					 goto go;


ex:

w.DeleteWindow();
close(handle);
close(sprhandle);
}


void delete_library(void)
{
WINDOW w(-1, -1, 260, 160,"Delete item", DLG_FRAME);
w.ShowWindow();
char delname[20];
int handle;
delname[0]=0;
char entry[100][100]; // DEBUG: Up to 100 sprites
char *lst[1000];

BUTTON del(w.x+20,w.y+135, 80, 20, "&Delete",kbDel);
BUTTON cancel(w.x+160,w.y+135, 80, 20, "&Cancel",kbEsc);
LIB_ITEM li;
LIB_HEADER lh;
del.ShowButton();
cancel.ShowButton();

if((getfile("*.SL", "Pick a library",delname))==0)
{

w.DeleteWindow();
return;

}

if((handle=open(delname,O_RDWR))==-1)
{
MessageBox("Unable to open .SL file",1);
}

 if((read(handle, &lh, 8))==-1)
{
MessageBox("Unable to read .SL header",1);
}

 if((lh.NK[0]!='N') || (lh.NK[1]!='K'))
{
MessageBox("Incorrect library header",1);
}

if(lh.version!=LIB_VERSION)
{
MessageBox("Incorrect library version",1);
}

// Loading .SL relocation table;
 read(handle, libitems, sizeof(li)*lh.maxitems);


for(int ii=0; ii<99;  ii++)
for(int zz=0; zz<99;  zz++)
 entry[zz][ii]=0;

int gg;
LIST list(w.x+8, w.y+60, 6, lh.defitems, 30, lst);
update:

gg=0;

for(int kk=0; kk<lh.maxitems; kk++)
{

if(libitems[kk].len!=0)
{
lst[gg]=libitems[kk].name;
gg++;
}

}

list.list_num=lh.defitems;
list.list=lst;

list.Show();



EVENT event;
go:

event=_GetEvent();

list.ProcessEvent(&event);
if(cancel.ProcessEvent(&event)==PRESSED) goto ex;
if(del.ProcessEvent(&event)==PRESSED)
{
int c=0;
int j;

if(lh.defitems<=0) goto go;

lh.defitems--;

for(j=0; j<lh.maxitems; j++)
{

if(libitems[j].len>0)
{

if(c==list.curr) {
libitems[j].len=0;
list.curr=0;
list.realshow=0;
goto update;

		  }
c++;

}

}

}

goto go;

ex:

 lseek(handle,0,SEEK_SET);

if(write(handle, &lh, sizeof(lh))==-1) goto err;

if(write(handle, libitems, sizeof(li)*lh.maxitems)==-1)
{
err:
MessageBoxf(1,"|~Unable to write relocation table in|~'%s'",delname);

}

close(handle);


real_optimize(delname);
w.DeleteWindow();

}


void optimize_library(void)
{
// Library Optimization:
char optname[20];
optname[0]=0;

if((getfile("*.SL", "Pick a library to optimize",optname))==0) return;
else real_optimize(optname);

}


void real_optimize(char *name)
{
WINDOW c(-1,-1,200,100,"Optimizing library",DLG_FRAME);
STATUSLINE p(c.x+20, c.y+50, 160, 1, libnumber );
LIB_ITEM li;
LIB_HEADER lh;
int handle;
int tmp;

unlink("__tmp.sl");

if((tmp=_creat("__tmp.sl",FA_ARCH))==-1)
{
  MessageBox("Unable to creat temporary file",1);
  return;
}

 if((handle=open(name,O_RDWR))==-1)
{
MessageBoxf(1,"Unable to open '%s'",name);
close(tmp);
return;
}

 if((read(handle, &lh, 8))==-1)
{
 MessageBoxf(1,"Unable to read '%s' header",name);
 close(handle);
 close(tmp);
 return;
}


if((lh.NK[0]!='N') || (lh.NK[1]!='K'))
{

MessageBox("Incorrect library header",1);
close(handle);
close(tmp);
return;

}


if(lh.version!=LIB_VERSION)
{

MessageBox("Incorrect library version",1);
close(handle);
close(tmp);
return;

}

 read(handle, libitems, sizeof(li)*lh.maxitems);

// Library Manipulating:
c.ShowWindow();
p.Show();

void *buffer=malloc(60000);
ShowMem();
int i;

if(buffer==0) { MessageBox("Not enough memory!",1); goto ex; }
for(i=0; i<lh.maxitems; i++)
{

if(libitems[i].len==0) { p.Add(1); continue; }

}

free(buffer);

ex:

close(handle);
rename(name,"__tmp.sl");
unlink("__tmp.sl");
c.DeleteWindow();
}