#include "stdio.h"
#include "dos.h"
#include "conio.h"
#include "io.h"
#include "fcntl.h"
#include "string.h"
#include "stdlib.h"

struct VREG {

char BIOSmode;
// start adress reg.
char SARhigh;
char SARlow;

int HTR;
int HDR;
int HSR;
int HSPWR;
int VTR;
int VTAR;
int VDR;
int VSPR;
int IMR;
int MSLR;
int CSR;
int CER;
int CLRh;
int CLRl;

int RR;
int CMR;
int CPWER;
int CGSR;
int MMR;

int SRR;
int SRER;
int CCR;
int DRFS;
int RPSR;
int MDR;
int MIR;
int CDCR;
int BMR;

int ModeControl;
int OFR;

} vreg;


void main(int argc,char **argv)
{
int h;
int tmp;
puts("REGister TALKer Version 1.0 BY Alex Chudnovsky");
if(argc==1) { puts("No REG file given!"); return; }

if((h=_open(argv[1],O_RDWR))==-1)
{
printf("Error: Unable to open REG file: %s;\n\r",argv[1]);
return;
}

_read(h,&vreg,sizeof(vreg));
close(h);

printf("\n\rBIOS reports video mode as : %Xh;\n\r",(int) vreg.BIOSmode);

tmp=vreg.SARhigh<<8;
tmp+=vreg.SARlow;
printf("Visual VRAM address        : %u;\n\r",tmp);

tmp=vreg.VTAR;

printf("Horizontal Total Register  : %Xh;\n\r",(unsigned) vreg.HTR);

printf("Horizontal Total Register  : %Xh;\n\r",(unsigned)vreg.HTR);
printf("Horizontal Displayed       : %Xh;\n\r",(unsigned)vreg.HDR);
printf("Horizontal Sync Position   : %Xh;\n\r",(unsigned)vreg.HSR);
printf("Horizontal Sync Pulse Width: %Xh;\n\r",(unsigned)vreg.HSPWR);
printf("Vertical Total Register    : %Xh;\n\r",(unsigned)vreg.VTR);
printf("Vertical Total Adjust      : %Xh;\n\r",tmp);
printf("Vertical Displayed         : %Xh;\n\r",(unsigned)vreg.VDR);
printf("Vertical Sync Position     : %Xh;\n\r",(unsigned)vreg.VSPR);
printf("Interlase Mode Register    : %Xh;\n\r",(unsigned)vreg.IMR);
printf("Max Scan Line Register     : %Xh;\n\r",(unsigned)vreg.MSLR);

printf("Reset Register             : %Xh;\n\r",(unsigned)vreg.RR);
printf("Clock Mode Register        : %Xh;\n\r",(unsigned)vreg.CMR);
printf("Color Plane Write Enable   : %Xh;\n\r",(unsigned)vreg.CPWER);
printf("Character Generator Select : %Xh;\n\r",(unsigned)vreg.CGSR);
printf("Memory Mode Register       : %Xh;\n\r",(unsigned)vreg.MMR);


printf("Set/Reset Register         : %Xh;\n\r",(unsigned)vreg.SRR);
printf("Set/Reset Enable Register  : %Xh;\n\r",(unsigned)vreg.SRER);
printf("Color Compare Register     : %Xh;\n\r",(unsigned)vreg.CCR);
printf("Data Rotate & Func Select  : %Xh;\n\r",(unsigned)vreg.DRFS);
printf("Read Plane Select Register : %Xh;\n\r",(unsigned)vreg.RPSR);

printf("Mode Register              : %Xh;\n\r",(unsigned)vreg.MDR);
printf("Miscellaneous Register     : %Xh;\n\r",(unsigned)vreg.MIR);
printf("Color Don't Care Register  : %Xh;\n\r",(unsigned)vreg.CDCR);
printf("Character Generator Select : %Xh;\n\r",(unsigned)vreg.CGSR);
printf("Bit Mask Register          : %Xh;\n\r",(unsigned)vreg.BMR);

printf("Mode Control (3d5h/17h)    : %Xh;\n\r",(unsigned)vreg.ModeControl);
printf("Logic Offset Register      : %Xh;\n\r",vreg.OFR);

}