#include "stdio.h"
#include "dos.h"
#include "conio.h"
#include "gamegrab.h"
#include "stdlib.h"
#include "stdio.h"
#include "time.h"
#include "string.h"
#include "fcntl.h"
#include "dos.h"
#include "stdarg.h"
#include "ctype.h"
#include "process.h"
#include "dir.h"
#include "io.h"
#include "alloc.h"

typedef struct _SPR_HDR_ {

char NK[2];      // Signature of Sprite Editor: 'NK';
char Version;
char VideoMode;
char Type;
int  SizeX;
int  SizeY;
int  DataLen;    // Lengh of base Data: mustn't be equal to zero;
int  MaskLen;    // Length of Mask: If zero -> no mask in sprite;

} SPR_HDR;



SPR_HDR icon;

void main(int argc,char **argv)
{
int handle;

puts("SPRite INFormator Version 1.0 BY Alex Chudnovsky");
puts("* * * Copyright (C) Mythical Software Group * * *");

if(argc==1)
{
puts("ERROR: Filename not specified in command line");
return;
}

handle=open(argv[1],O_RDWR);

if(handle==-1)
{
printf("ERROR: Can't open input file: ' %s '\n\r",argv[1]);
return;
}

if((_read(handle,&icon,sizeof(SPR_HDR)))==-1)
{
printf("ERROR: Can't read input file: ' %s '\n\r",argv[1]);
return;
}

  puts("-------------- Sprite Info --------------");
printf(" Version       :   %u\n\r",icon.Version);


printf(" Type          :   ");

switch(icon.Type)
{

case 0: puts("BGI oriented without mask"); break;

case 1: puts("BGI oriented with mask"); break;

case 3: puts("VGA 256 color;"); break;

case 80: puts("Explorer's pixel oriented type;"); break;

default: printf("*** Attention: Unknown sprite type detected: %d;\n\r",icon.Type); break;

};


printf(" SizeX         :   %u\n\r",icon.SizeX);
printf(" SizeY         :   %u\n\r",icon.SizeY);


printf(" For Video Mode:   ");

switch(icon.VideoMode)
{

case 0x0d: puts("EGA 320x200, 16 colors;"); break;
case 0x0e: puts("EGA 640x200, 16 colors;"); break;
case 0x10: puts("EGA 640x350, 16 colors;"); break;
case 0x12: puts("VGA 640x480, 16 colors;"); break;
case 0x13: puts("VGA 320x200, 256 colors;"); break;

default: printf("*** Attention: Unknown video mode: %d\n\r",icon.VideoMode); 
break;

};

printf(" DataLen       :   %u\n\r",icon.DataLen);

close(handle);

return;
}