#include "stdio.h"
#include "dos.h"
#include "conio.h"
#include "fcntl.h"

int  LoadPalette(char *PalFile);

typedef struct _SPR_HDR_ {

char NK[2];      // Signature of Sprite Editor: 'NK';
char Version;
char VideoMode;
char Type;
int  SizeX;
int  SizeY;
int  DataLen;    // Lengh of base Data: mustn't be equal to zero;
int  MaskLen;    // Length of Mask: If zero -> no mask in sprite;

} SPR_HDR;

SPR_HDR s,s2;

char Pal[256];
char mem1[30000];
char mem2[30000];

void putpixel(int x,int y,char col)
{
_AH=0x0c;
_BH=0;
_CX=x;
_DX=y;
_AL=col;
asm int 10h;
}


void main(int argc,char **argv)
{
int h,h2,c,x,y;
unsigned i;
char mode;
int bytes;
char color;

if(argc<3) { puts("SPRCONV SPR1.SPR SPR2.SPR"); return; }

if((h=_open(argv[1],O_RDWR))==-1)
{
printf("Unable to open '%s'",argv[1]);
return;
}

if((h2=_creat(argv[2],FA_ARCH))==-1)
{
printf("Unable to creat '%s'",argv[2]);
return;
}

if(_read(h,&s,sizeof(s))==-1)
{
printf("Unable to read '%s' header",argv[1]);
close(h);
return;
}

if((s.Type!=80) && (s.Type!=3))
{
printf("Bad type number: '%d'; (must be 80)",s.Type);
close(h);
return;
}

i=s.SizeX*s.SizeY;

if(_read(h,mem1,i)==-1)
{
printf("Unable to read '%s' header",argv[1]);
close(h);
return;
}




for(y=0; y<s.SizeY; y++)
for(x=0; x<s.SizeX; x++)
{
mem2[(x*s.SizeY)+y]=mem1[y*s.SizeX+x];
//printf("%d:%d to %d:%d; ",y*s.SizeY,x,(x*s.SizeY),y);
//getch();
// 11111
// 22222
// 33333

}


c=s.SizeX;
s.SizeX=s.SizeY;
s.SizeY=c;

_write(h2,&s,sizeof(s));
_write(h2,mem2,i);
close(h2);
close(h);
}


